// 
// Decompiled by Procyon v0.5.36
// 

package junit.textui;

import junit.runner.Version;
import junit.framework.TestListener;
import junit.runner.StandardTestSuiteLoader;
import junit.runner.TestSuiteLoader;
import junit.framework.TestResult;
import junit.framework.Test;
import junit.framework.TestSuite;
import java.io.PrintStream;
import junit.runner.BaseTestRunner;

public class TestRunner extends BaseTestRunner
{
    private ResultPrinter fPrinter;
    public static final int SUCCESS_EXIT = 0;
    public static final int FAILURE_EXIT = 1;
    public static final int EXCEPTION_EXIT = 2;
    
    public TestRunner() {
        this(System.out);
    }
    
    public TestRunner(final PrintStream writer) {
        this(new ResultPrinter(writer));
    }
    
    public TestRunner(final ResultPrinter printer) {
        this.fPrinter = printer;
    }
    
    public static void run(final Class testClass) {
        run(new TestSuite(testClass));
    }
    
    public static TestResult run(final Test test) {
        final TestRunner runner = new TestRunner();
        return runner.doRun(test);
    }
    
    public static void runAndWait(final Test suite) {
        final TestRunner aTestRunner = new TestRunner();
        aTestRunner.doRun(suite, true);
    }
    
    public TestSuiteLoader getLoader() {
        return new StandardTestSuiteLoader();
    }
    
    public void testFailed(final int status, final Test test, final Throwable t) {
    }
    
    public void testStarted(final String testName) {
    }
    
    public void testEnded(final String testName) {
    }
    
    protected TestResult createTestResult() {
        return new TestResult();
    }
    
    public TestResult doRun(final Test test) {
        return this.doRun(test, false);
    }
    
    public TestResult doRun(final Test suite, final boolean wait) {
        final TestResult result = this.createTestResult();
        result.addListener(this.fPrinter);
        final long startTime = System.currentTimeMillis();
        suite.run(result);
        final long endTime = System.currentTimeMillis();
        final long runTime = endTime - startTime;
        this.fPrinter.print(result, runTime);
        this.pause(wait);
        return result;
    }
    
    protected void pause(final boolean wait) {
        if (!wait) {
            return;
        }
        this.fPrinter.printWaitPrompt();
        try {
            System.in.read();
        }
        catch (Exception ex) {}
    }
    
    public static void main(final String[] args) {
        final TestRunner aTestRunner = new TestRunner();
        try {
            final TestResult r = aTestRunner.start(args);
            if (!r.wasSuccessful()) {
                System.exit(1);
            }
            System.exit(0);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            System.exit(2);
        }
    }
    
    protected TestResult start(final String[] args) throws Exception {
        String testCase = "";
        boolean wait = false;
        for (int i = 0; i < args.length; ++i) {
            if (args[i].equals("-wait")) {
                wait = true;
            }
            else if (args[i].equals("-c")) {
                testCase = this.extractClassName(args[++i]);
            }
            else if (args[i].equals("-v")) {
                System.err.println("JUnit " + Version.id() + " by Kent Beck and Erich Gamma");
            }
            else {
                testCase = args[i];
            }
        }
        if (testCase.equals("")) {
            throw new Exception("Usage: TestRunner [-wait] testCaseName, where name is the name of the TestCase class");
        }
        try {
            final Test suite = this.getTest(testCase);
            return this.doRun(suite, wait);
        }
        catch (Exception e) {
            throw new Exception("Could not create and run test suite: " + e);
        }
    }
    
    protected void runFailed(final String message) {
        System.err.println(message);
        System.exit(1);
    }
    
    public void setPrinter(final ResultPrinter printer) {
        this.fPrinter = printer;
    }
}
