// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit;

import org.bukkit.util.Vector;
import org.bukkit.block.Block;

public class Location implements Cloneable
{
    private World world;
    private double x;
    private double y;
    private double z;
    private float pitch;
    private float yaw;
    
    public Location(final World world, final double x, final double y, final double z) {
        this(world, x, y, z, 0.0f, 0.0f);
    }
    
    public Location(final World world, final double x, final double y, final double z, final float yaw, final float pitch) {
        this.world = world;
        this.x = x;
        this.y = y;
        this.z = z;
        this.pitch = pitch;
        this.yaw = yaw;
    }
    
    public void setWorld(final World world) {
        this.world = world;
    }
    
    public World getWorld() {
        return this.world;
    }
    
    public Block getBlock() {
        return this.world.getBlockAt(this);
    }
    
    public void setX(final double x) {
        this.x = x;
    }
    
    public double getX() {
        return this.x;
    }
    
    public int getBlockX() {
        return locToBlock(this.x);
    }
    
    public void setY(final double y) {
        this.y = y;
    }
    
    public double getY() {
        return this.y;
    }
    
    public int getBlockY() {
        return locToBlock(this.y);
    }
    
    public void setZ(final double z) {
        this.z = z;
    }
    
    public double getZ() {
        return this.z;
    }
    
    public int getBlockZ() {
        return locToBlock(this.z);
    }
    
    public void setYaw(final float yaw) {
        this.yaw = yaw;
    }
    
    public float getYaw() {
        return this.yaw;
    }
    
    public void setPitch(final float pitch) {
        this.pitch = pitch;
    }
    
    public float getPitch() {
        return this.pitch;
    }
    
    public Vector getDirection() {
        final Vector vector = new Vector();
        final double rotX = this.getYaw();
        final double rotY = this.getPitch();
        vector.setY(-Math.sin(Math.toRadians(rotY)));
        final double h = Math.cos(Math.toRadians(rotY));
        vector.setX(-h * Math.sin(Math.toRadians(rotX)));
        vector.setZ(h * Math.cos(Math.toRadians(rotX)));
        return vector;
    }
    
    @Override
    public boolean equals(final Object obj) {
        if (obj == null) {
            return false;
        }
        if (this.getClass() != obj.getClass()) {
            return false;
        }
        final Location other = (Location)obj;
        return (this.world == other.world || (this.world != null && this.world.equals(other.world))) && Double.doubleToLongBits(this.x) == Double.doubleToLongBits(other.x) && Double.doubleToLongBits(this.y) == Double.doubleToLongBits(other.y) && Double.doubleToLongBits(this.z) == Double.doubleToLongBits(other.z) && Float.floatToIntBits(this.pitch) == Float.floatToIntBits(other.pitch) && Float.floatToIntBits(this.yaw) == Float.floatToIntBits(other.yaw);
    }
    
    @Override
    public int hashCode() {
        int hash = 3;
        hash = 19 * hash + ((this.world != null) ? this.world.hashCode() : 0);
        hash = 19 * hash + (int)(Double.doubleToLongBits(this.x) ^ Double.doubleToLongBits(this.x) >>> 32);
        hash = 19 * hash + (int)(Double.doubleToLongBits(this.y) ^ Double.doubleToLongBits(this.y) >>> 32);
        hash = 19 * hash + (int)(Double.doubleToLongBits(this.z) ^ Double.doubleToLongBits(this.z) >>> 32);
        hash = 19 * hash + Float.floatToIntBits(this.pitch);
        hash = 19 * hash + Float.floatToIntBits(this.yaw);
        return hash;
    }
    
    @Override
    public String toString() {
        return "Location{world=" + this.world + "x=" + this.x + "y=" + this.y + "z=" + this.z + "pitch=" + this.pitch + "yaw=" + this.yaw + '}';
    }
    
    public Vector toVector() {
        return new Vector(this.x, this.y, this.z);
    }
    
    public Location clone() {
        return new Location(this.world, this.x, this.y, this.z, this.yaw, this.pitch);
    }
    
    public static int locToBlock(final double loc) {
        return (int)Math.floor(loc);
    }
}
