// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.command;

import org.bukkit.ChatColor;
import org.bukkit.plugin.Plugin;

public final class PluginCommand extends Command
{
    private final Plugin owningPlugin;
    
    public PluginCommand(final String name, final Plugin owner) {
        super(name);
        this.owningPlugin = owner;
        this.usageMessage = "";
    }
    
    @Override
    public boolean execute(final CommandSender sender, final String commandLabel, final String[] args) {
        boolean cmdSuccess = false;
        try {
            cmdSuccess = this.owningPlugin.onCommand(sender, this, commandLabel, args);
        }
        catch (Throwable ex) {
            throw new CommandException("Unhandled exception executing command '" + commandLabel + "' in plugin " + this.owningPlugin.getDescription().getFullName(), ex);
        }
        if (!cmdSuccess && !this.usageMessage.isEmpty()) {
            final String tmpMsg = this.usageMessage.replace("<command>", commandLabel);
            final String[] arr$;
            final String[] usageLines = arr$ = tmpMsg.split("\\n");
            for (String line : arr$) {
                while (line.length() > 0) {
                    final int stripChars = (line.length() > 53) ? 53 : line.length();
                    sender.sendMessage(ChatColor.RED + line.substring(0, stripChars));
                    line = line.substring(stripChars);
                }
            }
        }
        return cmdSuccess;
    }
}
