// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit;

import jline.ConsoleReader;
import org.bukkit.event.world.WorldEvent;
import org.bukkit.event.Event;
import net.minecraft.server.ChunkCoordinates;
import net.minecraft.server.Convertable;
import net.minecraft.server.IWorldAccess;
import net.minecraft.server.WorldManager;
import net.minecraft.server.IDataManager;
import net.minecraft.server.ServerNBTManager;
import net.minecraft.server.IProgressUpdate;
import net.minecraft.server.ConvertProgressUpdater;
import net.minecraft.server.WorldLoaderServer;
import java.util.Iterator;
import net.minecraft.server.WorldServer;
import net.minecraft.server.PropertyManager;
import org.bukkit.command.CommandSender;
import java.util.Collection;
import java.util.ArrayList;
import net.minecraft.server.EntityPlayer;
import org.bukkit.entity.Player;
import org.bukkit.command.Command;
import java.util.List;
import org.bukkit.command.PluginCommandYamlParser;
import org.bukkit.plugin.Plugin;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.bukkit.plugin.PluginLoader;
import org.bukkit.plugin.java.JavaPluginLoader;
import java.util.LinkedHashMap;
import org.bukkit.command.SimpleCommandMap;
import org.bukkit.craftbukkit.scheduler.CraftScheduler;
import org.bukkit.plugin.SimplePluginManager;
import org.bukkit.World;
import java.util.Map;
import net.minecraft.server.ServerConfigurationManager;
import net.minecraft.server.MinecraftServer;
import org.bukkit.command.CommandMap;
import org.bukkit.scheduler.BukkitScheduler;
import org.bukkit.plugin.PluginManager;
import org.bukkit.Server;

public final class CraftServer implements Server
{
    private final String serverName = "Craftbukkit";
    private final String serverVersion;
    private final String protocolVersion = "1.3";
    private final PluginManager pluginManager;
    private final BukkitScheduler scheduler;
    private final CommandMap commandMap;
    protected final MinecraftServer console;
    protected final ServerConfigurationManager server;
    private final Map<String, World> worlds;
    
    public CraftServer(final MinecraftServer console, final ServerConfigurationManager server) {
        this.pluginManager = new SimplePluginManager(this);
        this.scheduler = new CraftScheduler(this);
        this.commandMap = new SimpleCommandMap(this);
        this.worlds = new LinkedHashMap<String, World>();
        this.console = console;
        this.server = server;
        this.serverVersion = CraftServer.class.getPackage().getImplementationVersion();
        this.pluginManager.RegisterInterface(JavaPluginLoader.class);
        Logger.getLogger("Minecraft").log(Level.INFO, "This server is running " + this.getName() + " version " + this.getVersion());
    }
    
    public void loadPlugins() {
        final File pluginFolder = (File)this.console.options.valueOf("plugins");
        if (pluginFolder.exists()) {
            try {
                final Plugin[] arr$;
                final Plugin[] plugins = arr$ = this.pluginManager.loadPlugins(pluginFolder);
                for (final Plugin plugin : arr$) {
                    this.loadPlugin(plugin);
                }
            }
            catch (Throwable ex) {
                Logger.getLogger(CraftServer.class.getName()).log(Level.SEVERE, ex.getMessage() + " (Is it up to date?)", ex);
            }
        }
        else {
            pluginFolder.mkdir();
        }
    }
    
    public void disablePlugins() {
        this.pluginManager.disablePlugins();
    }
    
    private void loadPlugin(final Plugin plugin) {
        final List<Command> pluginCommands = PluginCommandYamlParser.parse(plugin);
        if (!pluginCommands.isEmpty()) {
            this.commandMap.registerAll(plugin.getDescription().getName(), pluginCommands);
        }
        this.pluginManager.enablePlugin(plugin);
    }
    
    public String getName() {
        return "Craftbukkit";
    }
    
    public String getVersion() {
        return this.serverVersion + " (MC: " + "1.3" + ")";
    }
    
    public Player[] getOnlinePlayers() {
        final List<EntityPlayer> online = (List<EntityPlayer>)this.server.b;
        final Player[] players = new Player[online.size()];
        for (int i = 0; i < players.length; ++i) {
            players[i] = online.get(i).a.getPlayer();
        }
        return players;
    }
    
    public Player getPlayer(final String name) {
        final Player[] players = this.getOnlinePlayers();
        Player found = null;
        final String lowerName = name.toLowerCase();
        int delta = Integer.MAX_VALUE;
        for (final Player player : players) {
            if (player.getName().toLowerCase().startsWith(lowerName)) {
                final int curDelta = player.getName().length() - lowerName.length();
                if (curDelta < delta) {
                    found = player;
                    delta = curDelta;
                }
                if (curDelta == 0) {
                    break;
                }
            }
        }
        return found;
    }
    
    public int broadcastMessage(final String message) {
        final Player[] arr$;
        final Player[] players = arr$ = this.getOnlinePlayers();
        for (final Player player : arr$) {
            player.sendMessage(message);
        }
        return players.length;
    }
    
    public Player getPlayer(final EntityPlayer entity) {
        return entity.a.getPlayer();
    }
    
    public List<Player> matchPlayer(final String partialName) {
        final List<Player> matchedPlayers = new ArrayList<Player>();
        for (final Player iterPlayer : this.getOnlinePlayers()) {
            final String iterPlayerName = iterPlayer.getName();
            if (partialName.equalsIgnoreCase(iterPlayerName)) {
                matchedPlayers.clear();
                matchedPlayers.add(iterPlayer);
                break;
            }
            if (iterPlayerName.toLowerCase().indexOf(partialName.toLowerCase()) != -1) {
                matchedPlayers.add(iterPlayer);
            }
        }
        return matchedPlayers;
    }
    
    public int getMaxPlayers() {
        return this.server.e;
    }
    
    public PluginManager getPluginManager() {
        return this.pluginManager;
    }
    
    public BukkitScheduler getScheduler() {
        return this.scheduler;
    }
    
    public List<World> getWorlds() {
        return new ArrayList<World>(this.worlds.values());
    }
    
    public ServerConfigurationManager getHandle() {
        return this.server;
    }
    
    public boolean dispatchCommand(final CommandSender sender, final String commandLine) {
        return this.commandMap.dispatch(sender, commandLine);
    }
    
    public void reload() {
        final PropertyManager config = new PropertyManager(this.console.options);
        this.console.d = config;
        final boolean animals = config.a("spawn-monsters", this.console.m);
        final boolean monsters = config.a("spawn-monsters", this.console.worlds.get(0).j > 0);
        this.console.l = config.a("online-mode", this.console.l);
        this.console.m = config.a("spawn-animals", this.console.m);
        this.console.n = config.a("pvp", this.console.n);
        for (final WorldServer world : this.console.worlds) {
            world.a((boolean)((world.j = (monsters ? 1 : 0)) != 0), animals);
        }
        this.pluginManager.clearPlugins();
        this.commandMap.clearCommands();
        this.loadPlugins();
    }
    
    @Override
    public String toString() {
        return "CraftServer{serverName=CraftbukkitserverVersion=" + this.serverVersion + "protocolVersion=" + "1.3" + '}';
    }
    
    public World createWorld(final String name, final World.Environment environment) {
        final File folder = new File(name);
        final World world = this.getWorld(name);
        if (world != null) {
            return world;
        }
        if (folder.exists() && !folder.isDirectory()) {
            throw new IllegalArgumentException("File exists with the name '" + name + "' and isn't a folder");
        }
        final Convertable converter = new WorldLoaderServer(folder);
        if (converter.a(name)) {
            this.getLogger().info("Converting world '" + name + "'");
            converter.a(name, new ConvertProgressUpdater(this.console));
        }
        final WorldServer internal = new WorldServer(this.console, new ServerNBTManager(new File("."), name, true), name, (environment == World.Environment.NETHER) ? -1 : 0);
        internal.a(new WorldManager(this.console, internal));
        internal.j = 1;
        internal.a(true, true);
        this.console.f.a(internal);
        this.console.worlds.add(internal);
        final short short1 = 196;
        long i = System.currentTimeMillis();
        for (int j = -short1; j <= short1; j += 16) {
            for (int k = -short1; k <= short1; k += 16) {
                final long l = System.currentTimeMillis();
                if (l < i) {
                    i = l;
                }
                if (l > i + 1000L) {
                    final int i2 = (short1 * 2 + 1) * (short1 * 2 + 1);
                    final int j2 = (j + short1) * (short1 * 2 + 1) + k + 1;
                    System.out.println("Preparing spawn area for " + name + ", " + j2 * 100 / i2 + "%");
                    i = l;
                }
                final ChunkCoordinates chunkcoordinates = internal.l();
                internal.u.d(chunkcoordinates.a + j >> 4, chunkcoordinates.c + k >> 4);
                while (internal.e()) {}
            }
        }
        return new CraftWorld(internal);
    }
    
    public MinecraftServer getServer() {
        return this.console;
    }
    
    public World getWorld(final String name) {
        return this.worlds.get(name.toLowerCase());
    }
    
    protected void addWorld(final World world) {
        this.worlds.put(world.getName().toLowerCase(), world);
        this.pluginManager.callEvent(new WorldEvent(Event.Type.WORLD_LOADED, world));
    }
    
    public Logger getLogger() {
        return MinecraftServer.a;
    }
    
    public ConsoleReader getReader() {
        return this.console.reader;
    }
}
