// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit;

import org.bukkit.entity.LivingEntity;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.server.TileEntity;
import net.minecraft.server.WorldGenTrees;
import net.minecraft.server.WorldGenTaiga1;
import net.minecraft.server.WorldGenTaiga2;
import net.minecraft.server.WorldGenForest;
import net.minecraft.server.WorldGenBigTree;
import org.bukkit.BlockChangeDelegate;
import org.bukkit.TreeType;
import org.bukkit.craftbukkit.entity.CraftEntity;
import net.minecraft.server.EntityTypes;
import net.minecraft.server.EntityCreature;
import org.bukkit.entity.Creature;
import org.bukkit.entity.CreatureType;
import net.minecraft.server.EntityBoat;
import org.bukkit.entity.Boat;
import org.bukkit.entity.PoweredMinecart;
import org.bukkit.entity.StorageMinecart;
import net.minecraft.server.EntityMinecart;
import org.bukkit.craftbukkit.entity.CraftMinecart;
import org.bukkit.entity.Minecart;
import net.minecraft.server.EntityArrow;
import org.bukkit.entity.Arrow;
import org.bukkit.util.Vector;
import org.bukkit.craftbukkit.entity.CraftItem;
import net.minecraft.server.Entity;
import net.minecraft.server.EntityItem;
import org.bukkit.entity.Item;
import org.bukkit.inventory.ItemStack;
import net.minecraft.server.IChunkProvider;
import org.bukkit.entity.Player;
import org.bukkit.Chunk;
import net.minecraft.server.ChunkCoordinates;
import org.bukkit.Location;
import org.bukkit.block.Block;
import net.minecraft.server.WorldProviderHell;
import java.util.Random;
import java.util.HashMap;
import net.minecraft.server.ChunkProviderServer;
import net.minecraft.server.WorldServer;
import org.bukkit.World;

public class CraftWorld implements World
{
    private final WorldServer world;
    private final Environment environment;
    private final CraftServer server;
    private final ChunkProviderServer provider;
    private HashMap<Integer, CraftChunk> unloadedChunks;
    private static final Random rand;
    
    public CraftWorld(final WorldServer world) {
        this.unloadedChunks = new HashMap<Integer, CraftChunk>();
        this.world = world;
        this.server = world.getServer();
        this.provider = world.u;
        if (world.m instanceof WorldProviderHell) {
            this.environment = Environment.NETHER;
        }
        else {
            this.environment = Environment.NORMAL;
        }
        this.server.addWorld(this);
    }
    
    public void preserveChunk(final CraftChunk chunk) {
        this.unloadedChunks.put((chunk.getX() << 16) + chunk.getZ(), chunk);
    }
    
    public CraftChunk popPreservedChunk(final int x, final int z) {
        return this.unloadedChunks.remove((x << 16) + z);
    }
    
    public Block getBlockAt(final int x, final int y, final int z) {
        return this.getChunkAt(x >> 4, z >> 4).getBlock(x & 0xF, y & 0x7F, z & 0xF);
    }
    
    public int getBlockTypeIdAt(final int x, final int y, final int z) {
        return this.world.getTypeId(x, y, z);
    }
    
    public int getHighestBlockYAt(final int x, final int z) {
        return this.world.d(x, z);
    }
    
    public Location getSpawnLocation() {
        final ChunkCoordinates spawn = this.world.l();
        return new Location(this, spawn.a, this.world.e(spawn.a, spawn.c), spawn.c);
    }
    
    public Chunk getChunkAt(final int x, final int z) {
        return this.provider.d(x, z).bukkitChunk;
    }
    
    public Chunk getChunkAt(final Block block) {
        return this.getChunkAt(block.getX() >> 4, block.getZ() >> 4);
    }
    
    public boolean isChunkLoaded(final int x, final int z) {
        return this.provider.a(x, z);
    }
    
    public Chunk[] getLoadedChunks() {
        final Object[] chunks = this.provider.e.values().toArray();
        final Chunk[] craftChunks = new CraftChunk[chunks.length];
        for (int i = 0; i < chunks.length; ++i) {
            final net.minecraft.server.Chunk chunk = (net.minecraft.server.Chunk)chunks[i];
            craftChunks[i] = chunk.bukkitChunk;
        }
        return craftChunks;
    }
    
    public void loadChunk(final int x, final int z) {
        this.loadChunk(x, z, true);
    }
    
    public boolean unloadChunk(final int x, final int z) {
        return this.unloadChunk(x, z, true);
    }
    
    public boolean unloadChunk(final int x, final int z, final boolean save) {
        return this.unloadChunk(x, z, save, false);
    }
    
    public boolean unloadChunkRequest(final int x, final int z) {
        return this.unloadChunkRequest(x, z, true);
    }
    
    public boolean unloadChunkRequest(final int x, final int z, final boolean safe) {
        if (safe && this.isChunkInUse(x, z)) {
            return false;
        }
        this.provider.c(x, z);
        return true;
    }
    
    public boolean unloadChunk(final int x, final int z, final boolean save, final boolean safe) {
        if (safe && this.isChunkInUse(x, z)) {
            return false;
        }
        final net.minecraft.server.Chunk chunk = this.provider.b(x, z);
        if (save) {
            chunk.e();
            this.provider.b(chunk);
            this.provider.a(chunk);
        }
        this.provider.a.remove(x, z);
        this.provider.a.remove(x, z);
        this.provider.e.remove(x, z);
        this.provider.f.remove(chunk);
        return true;
    }
    
    public boolean isChunkInUse(final int x, final int z) {
        final Player[] arr$;
        final Player[] players = arr$ = this.server.getOnlinePlayers();
        for (final Player player : arr$) {
            final Location loc = player.getLocation();
            if (loc.getWorld() == this.provider.g.getWorld()) {
                if (Math.abs(loc.getBlockX() - (x << 4)) <= 256 && Math.abs(loc.getBlockZ() - (z << 4)) <= 256) {
                    return false;
                }
            }
        }
        return true;
    }
    
    public boolean loadChunk(final int x, final int z, final boolean generate) {
        if (generate) {
            return this.provider.d(x, z) != null;
        }
        this.provider.a.remove(x, z);
        net.minecraft.server.Chunk chunk = this.provider.e.get(x, z);
        if (chunk == null) {
            chunk = this.provider.e(x, z);
            if (chunk != null) {
                this.provider.e.put(x, z, chunk);
                this.provider.f.add(chunk);
                chunk.c();
                chunk.d();
                if (!chunk.n && this.provider.a(x + 1, z + 1) && this.provider.a(x, z + 1) && this.provider.a(x + 1, z)) {
                    this.provider.a(this.provider, x, z);
                }
                if (this.provider.a(x - 1, z) && !this.provider.b(x - 1, z).n && this.provider.a(x - 1, z + 1) && this.provider.a(x, z + 1) && this.provider.a(x - 1, z)) {
                    this.provider.a(this.provider, x - 1, z);
                }
                if (this.provider.a(x, z - 1) && !this.provider.b(x, z - 1).n && this.provider.a(x + 1, z - 1) && this.provider.a(x, z - 1) && this.provider.a(x + 1, z)) {
                    this.provider.a(this.provider, x, z - 1);
                }
                if (this.provider.a(x - 1, z - 1) && !this.provider.b(x - 1, z - 1).n && this.provider.a(x - 1, z - 1) && this.provider.a(x, z - 1) && this.provider.a(x - 1, z)) {
                    this.provider.a(this.provider, x - 1, z - 1);
                }
            }
        }
        return chunk != null;
    }
    
    public boolean isChunkLoaded(final Chunk chunk) {
        return this.isChunkLoaded(chunk.getX(), chunk.getZ());
    }
    
    public void loadChunk(final Chunk chunk) {
        this.loadChunk(chunk.getX(), chunk.getZ());
        ((CraftChunk)this.getChunkAt(chunk.getX(), chunk.getZ())).getHandle().bukkitChunk = chunk;
    }
    
    public WorldServer getHandle() {
        return this.world;
    }
    
    public Item dropItem(final Location loc, final ItemStack item) {
        final net.minecraft.server.ItemStack stack = new net.minecraft.server.ItemStack(item.getTypeId(), item.getAmount(), item.getDurability());
        final EntityItem entity = new EntityItem(this.world, loc.getX(), loc.getY(), loc.getZ(), stack);
        entity.c = 10;
        this.world.a(entity);
        return new CraftItem(this.world.getServer(), entity);
    }
    
    public Item dropItemNaturally(Location loc, final ItemStack item) {
        final double xs = this.world.k.nextFloat() * 0.7f + 0.15000000596046448;
        final double ys = this.world.k.nextFloat() * 0.7f + 0.15000000596046448;
        final double zs = this.world.k.nextFloat() * 0.7f + 0.15000000596046448;
        loc = loc.clone();
        loc.setX(loc.getX() + xs);
        loc.setY(loc.getY() + ys);
        loc.setZ(loc.getZ() + zs);
        return this.dropItem(loc, item);
    }
    
    public Arrow spawnArrow(final Location loc, final Vector velocity, final float speed, final float spread) {
        final EntityArrow arrow = new EntityArrow(this.world);
        arrow.c(loc.getX(), loc.getY(), loc.getZ(), 0.0f, 0.0f);
        this.world.a(arrow);
        arrow.a(velocity.getX(), velocity.getY(), velocity.getZ(), speed, spread);
        return (Arrow)arrow.getBukkitEntity();
    }
    
    public Minecart spawnMinecart(final Location loc) {
        final EntityMinecart minecart = new EntityMinecart(this.world, loc.getX(), loc.getY(), loc.getZ(), CraftMinecart.Type.Minecart.getId());
        this.world.a(minecart);
        return (Minecart)minecart.getBukkitEntity();
    }
    
    public StorageMinecart spawnStorageMinecart(final Location loc) {
        final EntityMinecart minecart = new EntityMinecart(this.world, loc.getX(), loc.getY(), loc.getZ(), CraftMinecart.Type.StorageMinecart.getId());
        this.world.a(minecart);
        return (StorageMinecart)minecart.getBukkitEntity();
    }
    
    public PoweredMinecart spawnPoweredMinecart(final Location loc) {
        final EntityMinecart minecart = new EntityMinecart(this.world, loc.getX(), loc.getY(), loc.getZ(), CraftMinecart.Type.PoweredMinecart.getId());
        this.world.a(minecart);
        return (PoweredMinecart)minecart.getBukkitEntity();
    }
    
    public Boat spawnBoat(final Location loc) {
        final EntityBoat boat = new EntityBoat(this.world, loc.getX(), loc.getY(), loc.getZ());
        this.world.a(boat);
        return (Boat)boat.getBukkitEntity();
    }
    
    public Creature spawnCreature(final Location loc, final CreatureType creatureType) {
        Creature creature;
        try {
            final EntityCreature entityCreature = (EntityCreature)EntityTypes.a(creatureType.getName(), this.world);
            entityCreature.a(loc.getX(), loc.getY(), loc.getZ());
            creature = (Creature)CraftEntity.getEntity(this.server, entityCreature);
            this.world.a(entityCreature);
        }
        catch (Exception e) {
            creature = null;
        }
        return creature;
    }
    
    public boolean generateTree(final Location loc, final TreeType type) {
        return this.generateTree(loc, type, this.world);
    }
    
    public boolean generateTree(final Location loc, final TreeType type, final BlockChangeDelegate delegate) {
        switch (type) {
            case BIG_TREE: {
                return new WorldGenBigTree().generate(delegate, CraftWorld.rand, loc.getBlockX(), loc.getBlockY(), loc.getBlockZ());
            }
            case BIRCH: {
                return new WorldGenForest().generate(delegate, CraftWorld.rand, loc.getBlockX(), loc.getBlockY(), loc.getBlockZ());
            }
            case REDWOOD: {
                return new WorldGenTaiga2().generate(delegate, CraftWorld.rand, loc.getBlockX(), loc.getBlockY(), loc.getBlockZ());
            }
            case TALL_REDWOOD: {
                return new WorldGenTaiga1().generate(delegate, CraftWorld.rand, loc.getBlockX(), loc.getBlockY(), loc.getBlockZ());
            }
            default: {
                return new WorldGenTrees().generate(delegate, CraftWorld.rand, loc.getBlockX(), loc.getBlockY(), loc.getBlockZ());
            }
        }
    }
    
    public TileEntity getTileEntityAt(final int x, final int y, final int z) {
        return this.world.getTileEntity(x, y, z);
    }
    
    public String getName() {
        return this.world.q.j;
    }
    
    public long getId() {
        return this.world.q.b();
    }
    
    @Override
    public String toString() {
        return "CraftWorld{name=" + this.getName() + '}';
    }
    
    public long getTime() {
        long time = this.getFullTime() % 24000L;
        if (time < 0L) {
            time += 24000L;
        }
        return time;
    }
    
    public void setTime(final long time) {
        long margin = (time - this.getFullTime()) % 24000L;
        if (margin < 0L) {
            margin += 24000L;
        }
        this.setFullTime(this.getFullTime() + margin);
    }
    
    public long getFullTime() {
        return this.world.k();
    }
    
    public void setFullTime(final long time) {
        this.world.a(time);
    }
    
    public Environment getEnvironment() {
        return this.environment;
    }
    
    public Block getBlockAt(final Location location) {
        return this.getBlockAt(location.getBlockX(), location.getBlockY(), location.getBlockZ());
    }
    
    public int getBlockTypeIdAt(final Location location) {
        return this.getBlockTypeIdAt(location.getBlockX(), location.getBlockY(), location.getBlockZ());
    }
    
    public int getHighestBlockYAt(final Location location) {
        return this.getHighestBlockYAt(location.getBlockX(), location.getBlockZ());
    }
    
    public Chunk getChunkAt(final Location location) {
        return this.getChunkAt(location.getBlockX() >> 4, location.getBlockZ() >> 4);
    }
    
    public List<org.bukkit.entity.Entity> getEntities() {
        final List<org.bukkit.entity.Entity> list = new ArrayList<org.bukkit.entity.Entity>();
        for (final Object o : this.world.b) {
            if (o instanceof Entity) {
                final Entity mcEnt = (Entity)o;
                final org.bukkit.entity.Entity bukkitEntity = mcEnt.getBukkitEntity();
                if (bukkitEntity == null) {
                    continue;
                }
                list.add(bukkitEntity);
            }
        }
        return list;
    }
    
    public List<LivingEntity> getLivingEntities() {
        final List<LivingEntity> list = new ArrayList<LivingEntity>();
        for (final Object o : this.world.b) {
            if (o instanceof Entity) {
                final Entity mcEnt = (Entity)o;
                final org.bukkit.entity.Entity bukkitEntity = mcEnt.getBukkitEntity();
                if (bukkitEntity == null || !(bukkitEntity instanceof LivingEntity)) {
                    continue;
                }
                list.add((LivingEntity)bukkitEntity);
            }
        }
        return list;
    }
    
    static {
        rand = new Random();
    }
    
    private final class ChunkCoordinate
    {
        public final int x;
        public final int z;
        
        public ChunkCoordinate(final int x, final int z) {
            this.x = x;
            this.z = z;
        }
        
        @Override
        public boolean equals(final Object obj) {
            if (obj == null) {
                return false;
            }
            if (this.getClass() != obj.getClass()) {
                return false;
            }
            final ChunkCoordinate other = (ChunkCoordinate)obj;
            return this.x == other.x && this.z == other.z;
        }
        
        @Override
        public int hashCode() {
            int hash = 5;
            hash = 53 * hash + this.x;
            hash = 53 * hash + this.z;
            return hash;
        }
    }
}
