// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.block;

import net.minecraft.server.BiomeBase;
import org.bukkit.block.Biome;
import org.bukkit.block.BlockState;
import org.bukkit.block.BlockFace;
import org.bukkit.Material;
import org.bukkit.Chunk;
import org.bukkit.util.BlockVector;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.craftbukkit.CraftChunk;
import org.bukkit.block.Block;

public class CraftBlock implements Block
{
    private final CraftChunk chunk;
    private final int x;
    private final int y;
    private final int z;
    
    public CraftBlock(final CraftChunk chunk, final int x, final int y, final int z) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.chunk = chunk;
    }
    
    public World getWorld() {
        return this.chunk.getWorld();
    }
    
    public Location getLocation() {
        return new Location(this.getWorld(), this.x, this.y, this.z);
    }
    
    public BlockVector getVector() {
        return new BlockVector(this.x, this.y, this.z);
    }
    
    public int getX() {
        return this.x;
    }
    
    public int getY() {
        return this.y;
    }
    
    public int getZ() {
        return this.z;
    }
    
    public Chunk getChunk() {
        return this.chunk;
    }
    
    public void setData(final byte data) {
        this.chunk.getHandle().d.c(this.x, this.y, this.z, data);
    }
    
    public byte getRawData() {
        return (byte)this.chunk.getHandle().b(this.x & 0xF, this.y & 0x7F, this.z & 0xF);
    }
    
    public void setType(final Material type) {
        this.setTypeId(type.getId());
    }
    
    public boolean setTypeId(final int type) {
        return this.chunk.getHandle().d.e(this.x, this.y, this.z, type);
    }
    
    public Material getType() {
        return Material.getMaterial(this.getTypeId());
    }
    
    public int getTypeId() {
        return this.chunk.getHandle().a(this.x & 0xF, this.y & 0x7F, this.z & 0xF);
    }
    
    public byte getLightLevel() {
        return (byte)this.chunk.getHandle().d.j(this.x, this.y, this.z);
    }
    
    public Block getFace(final BlockFace face) {
        return this.getFace(face, 1);
    }
    
    public Block getFace(final BlockFace face, final int distance) {
        return this.getRelative(face.getModX() * distance, face.getModY() * distance, face.getModZ() * distance);
    }
    
    public Block getRelative(final int modX, final int modY, final int modZ) {
        return this.getWorld().getBlockAt(this.getX() + modX, this.getY() + modY, this.getZ() + modZ);
    }
    
    public Block getRelative(final BlockFace face) {
        return this.getRelative(face.getModX(), face.getModY(), face.getModZ());
    }
    
    public BlockFace getFace(final Block block) {
        final BlockFace[] arr$;
        final BlockFace[] values = arr$ = BlockFace.values();
        for (final BlockFace face : arr$) {
            if (this.getX() + face.getModX() == block.getX() && this.getY() + face.getModY() == block.getY() && this.getZ() + face.getModZ() == block.getZ()) {
                return face;
            }
        }
        return null;
    }
    
    @Override
    public String toString() {
        return "CraftBlock{chunk=" + this.chunk + "x=" + this.x + "y=" + this.y + "z=" + this.z + '}';
    }
    
    public static BlockFace notchToBlockFace(final int notch) {
        switch (notch) {
            case 0: {
                return BlockFace.DOWN;
            }
            case 1: {
                return BlockFace.UP;
            }
            case 2: {
                return BlockFace.EAST;
            }
            case 3: {
                return BlockFace.WEST;
            }
            case 4: {
                return BlockFace.NORTH;
            }
            case 5: {
                return BlockFace.SOUTH;
            }
            default: {
                return BlockFace.SELF;
            }
        }
    }
    
    public static int blockFaceToNotch(final BlockFace face) {
        switch (face) {
            case DOWN: {
                return 0;
            }
            case UP: {
                return 1;
            }
            case EAST: {
                return 2;
            }
            case WEST: {
                return 3;
            }
            case NORTH: {
                return 4;
            }
            case SOUTH: {
                return 5;
            }
            default: {
                return 7;
            }
        }
    }
    
    public BlockState getState() {
        final Material material = this.getType();
        switch (material) {
            case SIGN:
            case SIGN_POST:
            case WALL_SIGN: {
                return new CraftSign(this);
            }
            case CHEST: {
                return new CraftChest(this);
            }
            case BURNING_FURNACE:
            case FURNACE: {
                return new CraftFurnace(this);
            }
            case DISPENSER: {
                return new CraftDispenser(this);
            }
            case MOB_SPAWNER: {
                return new CraftCreatureSpawner(this);
            }
            case NOTE_BLOCK: {
                return new CraftNoteBlock(this);
            }
            default: {
                return new CraftBlockState(this);
            }
        }
    }
    
    public Biome getBiome() {
        final BiomeBase base = this.chunk.getHandle().d.a().a(this.chunk.getX(), this.chunk.getZ());
        if (base == BiomeBase.RAINFOREST) {
            return Biome.RAINFOREST;
        }
        if (base == BiomeBase.SWAMPLAND) {
            return Biome.SWAMPLAND;
        }
        if (base == BiomeBase.SEASONAL_FOREST) {
            return Biome.SEASONAL_FOREST;
        }
        if (base == BiomeBase.FOREST) {
            return Biome.FOREST;
        }
        if (base == BiomeBase.SAVANNA) {
            return Biome.SAVANNA;
        }
        if (base == BiomeBase.SHRUBLAND) {
            return Biome.SHRUBLAND;
        }
        if (base == BiomeBase.TAIGA) {
            return Biome.TAIGA;
        }
        if (base == BiomeBase.DESERT) {
            return Biome.DESERT;
        }
        if (base == BiomeBase.PLAINS) {
            return Biome.PLAINS;
        }
        if (base == BiomeBase.ICE_DESERT) {
            return Biome.ICE_DESERT;
        }
        if (base == BiomeBase.TUNDRA) {
            return Biome.TUNDRA;
        }
        if (base == BiomeBase.HELL) {
            return Biome.HELL;
        }
        return null;
    }
    
    public boolean isBlockPowered() {
        return this.chunk.getHandle().d.o(this.x, this.y, this.z);
    }
    
    public boolean isBlockIndirectlyPowered() {
        return this.chunk.getHandle().d.p(this.x, this.y, this.z);
    }
    
    @Override
    public boolean equals(final Object o) {
        return this == o;
    }
    
    public boolean isBlockFacePowered(final BlockFace face) {
        return this.chunk.getHandle().d.i(this.x, this.y, this.z, blockFaceToNotch(face));
    }
    
    public boolean isBlockFaceIndirectlyPowered(final BlockFace face) {
        return this.chunk.getHandle().d.j(this.x, this.y, this.z, blockFaceToNotch(face));
    }
    
    @Deprecated
    public byte getData() {
        return this.getRawData();
    }
}
