// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.block;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Chunk;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.material.MaterialData;
import org.bukkit.craftbukkit.CraftChunk;
import org.bukkit.craftbukkit.CraftWorld;
import org.bukkit.block.BlockState;

public class CraftBlockState implements BlockState
{
    private final CraftWorld world;
    private final CraftChunk chunk;
    private final int x;
    private final int y;
    private final int z;
    protected int type;
    protected MaterialData data;
    protected byte light;
    
    public CraftBlockState(final Block block) {
        this.world = (CraftWorld)block.getWorld();
        this.x = block.getX();
        this.y = block.getY();
        this.z = block.getZ();
        this.type = block.getTypeId();
        this.light = block.getLightLevel();
        this.chunk = (CraftChunk)block.getChunk();
        this.createData(block.getRawData());
    }
    
    public World getWorld() {
        return this.world;
    }
    
    public int getX() {
        return this.x;
    }
    
    public int getY() {
        return this.y;
    }
    
    public int getZ() {
        return this.z;
    }
    
    public Chunk getChunk() {
        return this.chunk;
    }
    
    public void setData(final MaterialData data) {
        final Material mat = this.getType();
        if (mat == null || mat.getData() == null) {
            this.data = data;
        }
        else {
            if (data.getClass() != mat.getData() && data.getClass() != MaterialData.class) {
                throw new IllegalArgumentException("Provided data is not of type " + mat.getData().getName() + ", found " + data.getClass().getName());
            }
            this.data = data;
        }
    }
    
    public MaterialData getData() {
        return this.data;
    }
    
    public void setType(final Material type) {
        this.setTypeId(type.getId());
    }
    
    public boolean setTypeId(final int type) {
        this.type = type;
        this.createData((byte)0);
        return true;
    }
    
    public Material getType() {
        return Material.getMaterial(this.getTypeId());
    }
    
    public int getTypeId() {
        return this.type;
    }
    
    public byte getLightLevel() {
        return this.light;
    }
    
    public Block getBlock() {
        return this.world.getBlockAt(this.x, this.y, this.z);
    }
    
    public boolean update() {
        return this.update(false);
    }
    
    public boolean update(final boolean force) {
        final Block block = this.getBlock();
        synchronized (block) {
            if (block.getType() != this.getType()) {
                if (!force) {
                    return false;
                }
                block.setTypeId(this.getTypeId());
            }
            block.setData(this.getRawData());
        }
        return true;
    }
    
    private void createData(final byte data) {
        final Material mat = Material.getMaterial(this.type);
        if (mat == null || mat.getData() == null) {
            this.data = new MaterialData(this.type, data);
        }
        else {
            this.data = mat.getNewData(data);
        }
    }
    
    public byte getRawData() {
        return this.data.getData();
    }
    
    public Location getLocation() {
        return new Location(this.world, this.x, this.y, this.z);
    }
    
    public void setData(final byte data) {
        this.createData(data);
    }
}
