// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.entity;

import org.bukkit.Server;
import org.bukkit.craftbukkit.CraftWorld;
import net.minecraft.server.WorldServer;
import org.bukkit.World;
import org.bukkit.util.Vector;
import org.bukkit.Location;
import net.minecraft.server.EntityTNTPrimed;
import net.minecraft.server.EntitySnowball;
import net.minecraft.server.EntityPainting;
import net.minecraft.server.EntityMinecart;
import net.minecraft.server.EntityItem;
import net.minecraft.server.EntityFish;
import net.minecraft.server.EntityFireball;
import net.minecraft.server.EntityFallingSand;
import net.minecraft.server.EntityEgg;
import net.minecraft.server.EntityBoat;
import net.minecraft.server.EntityArrow;
import net.minecraft.server.EntityGhast;
import net.minecraft.server.EntityFlying;
import net.minecraft.server.EntitySlime;
import net.minecraft.server.EntitySquid;
import net.minecraft.server.EntityWaterAnimal;
import net.minecraft.server.EntitySpider;
import net.minecraft.server.EntitySkeleton;
import net.minecraft.server.EntityGiantZombie;
import net.minecraft.server.EntityCreeper;
import net.minecraft.server.EntityPigZombie;
import net.minecraft.server.EntityZombie;
import net.minecraft.server.EntityMonster;
import net.minecraft.server.EntitySheep;
import net.minecraft.server.EntityPig;
import net.minecraft.server.EntityCow;
import net.minecraft.server.EntityChicken;
import net.minecraft.server.EntityAnimal;
import net.minecraft.server.EntityCreature;
import net.minecraft.server.EntityPlayer;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.EntityLiving;
import org.bukkit.craftbukkit.CraftServer;
import org.bukkit.entity.Entity;

public abstract class CraftEntity implements Entity
{
    protected final CraftServer server;
    private net.minecraft.server.Entity entity;
    
    public CraftEntity(final CraftServer server, final net.minecraft.server.Entity entity) {
        this.server = server;
        this.entity = entity;
    }
    
    public static CraftEntity getEntity(final CraftServer server, final net.minecraft.server.Entity entity) {
        if (entity instanceof EntityLiving) {
            if (entity instanceof EntityHuman) {
                if (entity instanceof EntityPlayer) {
                    return new CraftPlayer(server, (EntityPlayer)entity);
                }
                return new CraftHumanEntity(server, (EntityHuman)entity);
            }
            else if (entity instanceof EntityCreature) {
                if (entity instanceof EntityAnimal) {
                    if (entity instanceof EntityChicken) {
                        return new CraftChicken(server, (EntityChicken)entity);
                    }
                    if (entity instanceof EntityCow) {
                        return new CraftCow(server, (EntityCow)entity);
                    }
                    if (entity instanceof EntityPig) {
                        return new CraftPig(server, (EntityPig)entity);
                    }
                    if (entity instanceof EntitySheep) {
                        return new CraftSheep(server, (EntitySheep)entity);
                    }
                    return new CraftAnimals(server, (EntityAnimal)entity);
                }
                else if (entity instanceof EntityMonster) {
                    if (entity instanceof EntityZombie) {
                        if (entity instanceof EntityPigZombie) {
                            return new CraftPigZombie(server, (EntityPigZombie)entity);
                        }
                        return new CraftZombie(server, (EntityZombie)entity);
                    }
                    else {
                        if (entity instanceof EntityCreeper) {
                            return new CraftCreeper(server, (EntityCreeper)entity);
                        }
                        if (entity instanceof EntityGiantZombie) {
                            return new CraftGiant(server, (EntityGiantZombie)entity);
                        }
                        if (entity instanceof EntitySkeleton) {
                            return new CraftSkeleton(server, (EntitySkeleton)entity);
                        }
                        if (entity instanceof EntitySpider) {
                            return new CraftSpider(server, (EntitySpider)entity);
                        }
                        return new CraftMonster(server, (EntityMonster)entity);
                    }
                }
                else {
                    if (!(entity instanceof EntityWaterAnimal)) {
                        return new CraftCreature(server, (EntityCreature)entity);
                    }
                    if (entity instanceof EntitySquid) {
                        return new CraftSquid(server, (EntitySquid)entity);
                    }
                    return new CraftWaterMob(server, (EntityWaterAnimal)entity);
                }
            }
            else {
                if (entity instanceof EntitySlime) {
                    return new CraftSlime(server, (EntitySlime)entity);
                }
                if (!(entity instanceof EntityFlying)) {
                    return new CraftLivingEntity(server, (EntityLiving)entity);
                }
                if (entity instanceof EntityGhast) {
                    return new CraftGhast(server, (EntityGhast)entity);
                }
                return new CraftFlying(server, (EntityFlying)entity);
            }
        }
        else {
            if (entity instanceof EntityArrow) {
                return new CraftArrow(server, (EntityArrow)entity);
            }
            if (entity instanceof EntityBoat) {
                return new CraftBoat(server, (EntityBoat)entity);
            }
            if (entity instanceof EntityEgg) {
                return new CraftEgg(server, (EntityEgg)entity);
            }
            if (entity instanceof EntityFallingSand) {
                return new CraftFallingSand(server, (EntityFallingSand)entity);
            }
            if (entity instanceof EntityFireball) {
                return new CraftFireball(server, (EntityFireball)entity);
            }
            if (entity instanceof EntityFish) {
                return new CraftFish(server, (EntityFish)entity);
            }
            if (entity instanceof EntityItem) {
                return new CraftItem(server, (EntityItem)entity);
            }
            if (entity instanceof EntityMinecart) {
                final EntityMinecart mc = (EntityMinecart)entity;
                if (mc.d == CraftMinecart.Type.StorageMinecart.getId()) {
                    return new CraftStorageMinecart(server, mc);
                }
                if (mc.d == CraftMinecart.Type.PoweredMinecart.getId()) {
                    return new CraftPoweredMinecart(server, mc);
                }
                return new CraftMinecart(server, mc);
            }
            else {
                if (entity instanceof EntityPainting) {
                    return new CraftPainting(server, (EntityPainting)entity);
                }
                if (entity instanceof EntitySnowball) {
                    return new CraftSnowball(server, (EntitySnowball)entity);
                }
                if (entity instanceof EntityTNTPrimed) {
                    return new CraftTNTPrimed(server, (EntityTNTPrimed)entity);
                }
                throw new IllegalArgumentException("Unknown entity");
            }
        }
    }
    
    public Location getLocation() {
        return new Location(this.getWorld(), this.entity.locX, this.entity.locY, this.entity.locZ, this.entity.yaw, this.entity.pitch);
    }
    
    public Vector getVelocity() {
        return new Vector(this.entity.motX, this.entity.motY, this.entity.motZ);
    }
    
    public void setVelocity(final Vector vel) {
        this.entity.motX = vel.getX();
        this.entity.motY = vel.getY();
        this.entity.motZ = vel.getZ();
    }
    
    public World getWorld() {
        return ((WorldServer)this.entity.world).getWorld();
    }
    
    public void teleportTo(final Location location) {
        this.entity.world = ((CraftWorld)location.getWorld()).getHandle();
        this.entity.b(location.getX(), location.getY(), location.getZ(), location.getYaw(), location.getPitch());
    }
    
    public void teleportTo(final Entity destination) {
        this.teleportTo(destination.getLocation());
    }
    
    public int getEntityId() {
        return this.entity.id;
    }
    
    public int getFireTicks() {
        return this.entity.fireTicks;
    }
    
    public int getMaxFireTicks() {
        return this.entity.maxFireTicks;
    }
    
    public void setFireTicks(final int ticks) {
        this.entity.fireTicks = ticks;
    }
    
    public void remove() {
        this.entity.dead = true;
    }
    
    public net.minecraft.server.Entity getHandle() {
        return this.entity;
    }
    
    public void setHandle(final net.minecraft.server.Entity entity) {
        this.entity = entity;
    }
    
    @Override
    public boolean equals(final Object obj) {
        if (obj == null) {
            return false;
        }
        if (this.getClass() != obj.getClass()) {
            return false;
        }
        final CraftEntity other = (CraftEntity)obj;
        return (this.server == other.server || (this.server != null && this.server.equals(other.server))) && (this.entity == other.entity || (this.entity != null && this.entity.equals(other.entity)));
    }
    
    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + ((this.server != null) ? this.server.hashCode() : 0);
        hash = 89 * hash + ((this.entity != null) ? this.entity.hashCode() : 0);
        return hash;
    }
    
    @Override
    public String toString() {
        return "CraftEntity{id=" + this.getEntityId() + '}';
    }
    
    public CraftServer getServer() {
        return this.server;
    }
}
