// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.entity;

import org.bukkit.entity.Vehicle;
import net.minecraft.server.EntityArrow;
import org.bukkit.entity.Arrow;
import java.util.Iterator;
import org.bukkit.util.BlockIterator;
import java.util.ArrayList;
import org.bukkit.block.Block;
import java.util.List;
import java.util.HashSet;
import net.minecraft.server.EntitySnowball;
import org.bukkit.entity.Snowball;
import net.minecraft.server.World;
import net.minecraft.server.EntityEgg;
import org.bukkit.craftbukkit.CraftWorld;
import org.bukkit.entity.Egg;
import net.minecraft.server.Entity;
import org.bukkit.craftbukkit.CraftServer;
import net.minecraft.server.EntityLiving;
import org.bukkit.entity.LivingEntity;

public class CraftLivingEntity extends CraftEntity implements LivingEntity
{
    private EntityLiving entity;
    
    public CraftLivingEntity(final CraftServer server, final EntityLiving entity) {
        super(server, entity);
        this.entity = entity;
    }
    
    public int getHealth() {
        return this.entity.health;
    }
    
    public void setHealth(final int health) {
        if (health < 0 || health > 200) {
            throw new IllegalArgumentException("Health must be between 0 and 200");
        }
        this.entity.health = health;
    }
    
    @Override
    public EntityLiving getHandle() {
        return this.entity;
    }
    
    public void setHandle(final EntityLiving entity) {
        super.setHandle(entity);
        this.entity = entity;
    }
    
    @Override
    public String toString() {
        return "CraftLivingEntity{id=" + this.getEntityId() + '}';
    }
    
    public Egg throwEgg() {
        final World world = ((CraftWorld)this.getWorld()).getHandle();
        final EntityEgg egg = new EntityEgg(world, this.entity);
        world.a(egg);
        return (Egg)egg.getBukkitEntity();
    }
    
    public Snowball throwSnowball() {
        final World world = ((CraftWorld)this.getWorld()).getHandle();
        final EntitySnowball snowball = new EntitySnowball(world, this.entity);
        world.a(snowball);
        return (Snowball)snowball.getBukkitEntity();
    }
    
    public double getEyeHeight() {
        return 1.0;
    }
    
    public double getEyeHeight(final boolean ignoreSneaking) {
        return this.getEyeHeight();
    }
    
    private List<Block> getLineOfSight(final HashSet<Byte> transparent, int maxDistance, final int maxLength) {
        if (maxDistance > 120) {
            maxDistance = 120;
        }
        final ArrayList<Block> blocks = new ArrayList<Block>();
        final Iterator<Block> itr = new BlockIterator(this, maxDistance);
        while (itr.hasNext()) {
            final Block block = itr.next();
            blocks.add(block);
            if (maxLength != 0 && blocks.size() > maxLength) {
                blocks.remove(0);
            }
            final int id = block.getTypeId();
            if (transparent == null) {
                if (id != 0) {
                    break;
                }
                continue;
            }
            else {
                if (!transparent.contains((byte)id)) {
                    break;
                }
                continue;
            }
        }
        return blocks;
    }
    
    public List<Block> getLineOfSight(final HashSet<Byte> transparent, final int maxDistance) {
        return this.getLineOfSight(transparent, maxDistance, 0);
    }
    
    public Block getTargetBlock(final HashSet<Byte> transparent, final int maxDistance) {
        final List<Block> blocks = this.getLineOfSight(transparent, maxDistance, 1);
        return blocks.get(0);
    }
    
    public List<Block> getLastTwoTargetBlocks(final HashSet<Byte> transparent, final int maxDistance) {
        return this.getLineOfSight(transparent, maxDistance, 2);
    }
    
    public Arrow shootArrow() {
        final World world = ((CraftWorld)this.getWorld()).getHandle();
        final EntityArrow arrow = new EntityArrow(world, this.entity);
        world.a(arrow);
        return (Arrow)arrow.getBukkitEntity();
    }
    
    public boolean isInsideVehicle() {
        return this.entity.vehicle != null;
    }
    
    public boolean leaveVehicle() {
        if (this.entity.vehicle == null) {
            return false;
        }
        this.entity.setPassengerOf(null);
        return true;
    }
    
    public Vehicle getVehicle() {
        if (this.entity.vehicle == null) {
            return null;
        }
        final Entity vehicle = this.entity.vehicle.getBukkitEntity();
        if (vehicle instanceof Vehicle) {
            return (Vehicle)vehicle;
        }
        return null;
    }
    
    public int getRemainingAir() {
        return this.entity.airTicks;
    }
    
    public void setRemainingAir(final int ticks) {
        this.entity.airTicks = ticks;
    }
    
    public int getMaximumAir() {
        return this.entity.maxAirTicks;
    }
    
    public void setMaximumAir(final int ticks) {
        this.entity.maxAirTicks = ticks;
    }
}
