// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.inventory;

import java.util.HashMap;
import org.bukkit.Material;
import net.minecraft.server.ItemStack;
import net.minecraft.server.IInventory;
import org.bukkit.inventory.Inventory;

public class CraftInventory implements Inventory
{
    protected IInventory inventory;
    
    public CraftInventory(final IInventory inventory) {
        this.inventory = inventory;
    }
    
    public IInventory getInventory() {
        return this.inventory;
    }
    
    public int getSize() {
        return this.getInventory().m_();
    }
    
    public String getName() {
        return this.getInventory().c();
    }
    
    public CraftItemStack getItem(final int index) {
        return new CraftItemStack(this.getInventory().c_(index));
    }
    
    public CraftItemStack[] getContents() {
        final CraftItemStack[] items = new CraftItemStack[this.getSize()];
        final ItemStack[] mcItems = this.getInventory().getContents();
        for (int i = 0; i < mcItems.length; ++i) {
            items[i] = new CraftItemStack(mcItems[i]);
        }
        return items;
    }
    
    public void setContents(final org.bukkit.inventory.ItemStack[] items) {
        if (this.getInventory().getContents().length != items.length) {
            throw new IllegalArgumentException("Invalid inventory size; expected " + this.getInventory().getContents().length);
        }
        final ItemStack[] mcItems = this.getInventory().getContents();
        for (int i = 0; i < items.length; ++i) {
            final org.bukkit.inventory.ItemStack item = items[i];
            if (item == null || item.getTypeId() <= 0) {
                mcItems[i] = null;
            }
            else {
                mcItems[i] = new ItemStack(item.getTypeId(), item.getAmount(), item.getDurability());
            }
        }
    }
    
    public void setItem(final int index, final org.bukkit.inventory.ItemStack item) {
        this.getInventory().a(index, (item == null) ? null : new ItemStack(item.getTypeId(), item.getAmount(), item.getDurability()));
    }
    
    public boolean contains(final int materialId) {
        for (final org.bukkit.inventory.ItemStack item : this.getContents()) {
            if (item.getTypeId() == materialId) {
                return true;
            }
        }
        return false;
    }
    
    public boolean contains(final Material material) {
        return this.contains(material.getId());
    }
    
    public boolean contains(final org.bukkit.inventory.ItemStack item) {
        for (final org.bukkit.inventory.ItemStack i : this.getContents()) {
            if (item.equals(i)) {
                return true;
            }
        }
        return false;
    }
    
    public boolean contains(final int materialId, final int amount) {
        for (final org.bukkit.inventory.ItemStack item : this.getContents()) {
            if (item.getTypeId() == materialId && item.getAmount() >= amount) {
                return true;
            }
        }
        return false;
    }
    
    public boolean contains(final Material material, final int amount) {
        return this.contains(material.getId(), amount);
    }
    
    public boolean contains(final org.bukkit.inventory.ItemStack item, final int amount) {
        for (final org.bukkit.inventory.ItemStack i : this.getContents()) {
            if (item.equals(i) && item.getAmount() >= amount) {
                return true;
            }
        }
        return false;
    }
    
    public HashMap<Integer, CraftItemStack> all(final int materialId) {
        final HashMap<Integer, CraftItemStack> slots = new HashMap<Integer, CraftItemStack>();
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            final CraftItemStack item = inventory[i];
            if (item.getTypeId() == materialId) {
                slots.put(i, item);
            }
        }
        return slots;
    }
    
    public HashMap<Integer, CraftItemStack> all(final Material material) {
        return this.all(material.getId());
    }
    
    public HashMap<Integer, CraftItemStack> all(final org.bukkit.inventory.ItemStack item) {
        final HashMap<Integer, CraftItemStack> slots = new HashMap<Integer, CraftItemStack>();
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            if (item.equals(inventory[i])) {
                slots.put(i, inventory[i]);
            }
        }
        return slots;
    }
    
    public int first(final int materialId) {
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            if (inventory[i].getTypeId() == materialId) {
                return i;
            }
        }
        return -1;
    }
    
    public int first(final Material material) {
        return this.first(material.getId());
    }
    
    public int first(final org.bukkit.inventory.ItemStack item) {
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            if (item.equals(inventory[i])) {
                return i;
            }
        }
        return -1;
    }
    
    public int firstEmpty() {
        return this.first(Material.AIR);
    }
    
    public int firstPartial(final int materialId) {
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            final CraftItemStack item = inventory[i];
            if (item != null && item.getTypeId() == materialId && item.getAmount() < item.getMaxStackSize()) {
                return i;
            }
        }
        return -1;
    }
    
    public int firstPartial(final Material material) {
        return this.firstPartial(material.getId());
    }
    
    public int firstPartial(final org.bukkit.inventory.ItemStack item) {
        final CraftItemStack[] inventory = this.getContents();
        for (int i = 0; i < inventory.length; ++i) {
            final CraftItemStack cItem = inventory[i];
            if (item != null && cItem.getTypeId() == item.getTypeId() && cItem.getAmount() < cItem.getMaxStackSize() && cItem.getDurability() == item.getDurability()) {
                return i;
            }
        }
        return -1;
    }
    
    public HashMap<Integer, org.bukkit.inventory.ItemStack> addItem(final org.bukkit.inventory.ItemStack... items) {
        final HashMap<Integer, org.bukkit.inventory.ItemStack> leftover = new HashMap<Integer, org.bukkit.inventory.ItemStack>();
        for (int i = 0; i < items.length; ++i) {
            final org.bukkit.inventory.ItemStack item = items[i];
            while (true) {
                final int firstPartial = this.firstPartial(item);
                if (firstPartial == -1) {
                    final int firstFree = this.firstEmpty();
                    if (firstFree == -1) {
                        leftover.put(i, item);
                        break;
                    }
                    if (item.getAmount() <= this.getMaxItemStack()) {
                        this.setItem(firstFree, item);
                        break;
                    }
                    this.setItem(firstFree, new CraftItemStack(item.getTypeId(), this.getMaxItemStack(), item.getDurability()));
                    item.setAmount(item.getAmount() - this.getMaxItemStack());
                }
                else {
                    final CraftItemStack partialItem = this.getItem(firstPartial);
                    final int amount = item.getAmount();
                    final int partialAmount = partialItem.getAmount();
                    final int maxAmount = partialItem.getMaxStackSize();
                    if (amount + partialAmount <= maxAmount) {
                        partialItem.setAmount(amount + partialAmount);
                        break;
                    }
                    partialItem.setAmount(maxAmount);
                    item.setAmount(amount + partialAmount - maxAmount);
                }
            }
        }
        return leftover;
    }
    
    public HashMap<Integer, org.bukkit.inventory.ItemStack> removeItem(final org.bukkit.inventory.ItemStack... items) {
        final HashMap<Integer, org.bukkit.inventory.ItemStack> leftover = new HashMap<Integer, org.bukkit.inventory.ItemStack>();
        for (int i = 0; i < items.length; ++i) {
            final org.bukkit.inventory.ItemStack item = items[i];
            int toDelete = item.getAmount();
            do {
                final int first = this.first(item.getType());
                if (first == -1) {
                    item.setAmount(toDelete);
                    leftover.put(i, item);
                    break;
                }
                final CraftItemStack itemStack = this.getItem(first);
                final int amount = itemStack.getAmount();
                if (amount <= toDelete) {
                    toDelete -= amount;
                    this.clear(first);
                }
                else {
                    itemStack.setAmount(amount - toDelete);
                    this.setItem(first, itemStack);
                    toDelete = 0;
                }
            } while (toDelete > 0);
        }
        return leftover;
    }
    
    private int getMaxItemStack() {
        return this.getInventory().n_();
    }
    
    public void remove(final int materialId) {
        final org.bukkit.inventory.ItemStack[] items = this.getContents();
        for (int i = 0; i < items.length; ++i) {
            if (items[i].getTypeId() == materialId) {
                this.clear(i);
            }
        }
    }
    
    public void remove(final Material material) {
        this.remove(material.getId());
    }
    
    public void remove(final org.bukkit.inventory.ItemStack item) {
        final org.bukkit.inventory.ItemStack[] items = this.getContents();
        for (int i = 0; i < items.length; ++i) {
            if (items[i].equals(item)) {
                this.clear(i);
            }
        }
    }
    
    public void clear(final int index) {
        this.setItem(index, null);
    }
    
    public void clear() {
        for (int i = 0; i < this.getSize(); ++i) {
            this.clear(i);
        }
    }
}
