// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.scheduler;

import org.bukkit.plugin.Plugin;

public class CraftTask implements Comparable<Object>
{
    private final Runnable task;
    private final boolean syncTask;
    private long executionTick;
    private final long period;
    private final Plugin owner;
    private final int idNumber;
    private static Integer idCounter;
    private static Object idCounterSync;
    
    CraftTask(final Plugin owner, final Runnable task, final boolean syncTask) {
        this(owner, task, syncTask, -1L, -1L);
    }
    
    CraftTask(final Plugin owner, final Runnable task, final boolean syncTask, final long executionTick) {
        this(owner, task, syncTask, executionTick, -1L);
    }
    
    CraftTask(final Plugin owner, final Runnable task, final boolean syncTask, final long executionTick, final long period) {
        this.task = task;
        this.syncTask = syncTask;
        this.executionTick = executionTick;
        this.period = period;
        this.owner = owner;
        this.idNumber = getNextId();
    }
    
    static int getNextId() {
        synchronized (CraftTask.idCounterSync) {
            final Integer idCounter = CraftTask.idCounter;
            ++CraftTask.idCounter;
            return CraftTask.idCounter;
        }
    }
    
    Runnable getTask() {
        return this.task;
    }
    
    boolean isSync() {
        return this.syncTask;
    }
    
    long getExecutionTick() {
        return this.executionTick;
    }
    
    long getPeriod() {
        return this.period;
    }
    
    Plugin getOwner() {
        return this.owner;
    }
    
    void updateExecution() {
        this.executionTick += this.period;
    }
    
    int getIdNumber() {
        return this.idNumber;
    }
    
    public int compareTo(final Object other) {
        if (!(other instanceof CraftTask)) {
            return 0;
        }
        final CraftTask o = (CraftTask)other;
        final long timeDiff = this.executionTick - o.getExecutionTick();
        if (timeDiff > 0L) {
            return 1;
        }
        if (timeDiff < 0L) {
            return -1;
        }
        final CraftTask otherCraftTask = (CraftTask)other;
        return this.getIdNumber() - otherCraftTask.getIdNumber();
    }
    
    @Override
    public boolean equals(final Object other) {
        if (other == null) {
            return false;
        }
        if (!(other instanceof CraftTask)) {
            return false;
        }
        final CraftTask otherCraftTask = (CraftTask)other;
        return otherCraftTask.getIdNumber() == this.getIdNumber();
    }
    
    @Override
    public int hashCode() {
        return this.getIdNumber();
    }
    
    static {
        CraftTask.idCounter = 1;
        CraftTask.idCounterSync = new Object();
    }
}
