// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.scheduler;

import java.util.Iterator;
import org.bukkit.plugin.Plugin;
import java.util.HashSet;

public class CraftThreadManager
{
    final HashSet<CraftWorker> workers;
    
    public CraftThreadManager() {
        this.workers = new HashSet<CraftWorker>();
    }
    
    void executeTask(final Runnable task, final Plugin owner, final int taskId) {
        final CraftWorker craftWorker = new CraftWorker(this, task, owner, taskId);
        synchronized (this.workers) {
            this.workers.add(craftWorker);
        }
    }
    
    void interruptTask(final int taskId) {
        synchronized (this.workers) {
            for (final CraftWorker craftWorker : this.workers) {
                if (craftWorker.getTaskId() == taskId) {
                    craftWorker.interrupt();
                }
            }
        }
    }
    
    void interruptTasks(final Plugin owner) {
        synchronized (this.workers) {
            for (final CraftWorker craftWorker : this.workers) {
                if (craftWorker.getOwner().equals(owner)) {
                    craftWorker.interrupt();
                }
            }
        }
    }
    
    void interruptAllTasks() {
        synchronized (this.workers) {
            for (final CraftWorker craftWorker : this.workers) {
                craftWorker.interrupt();
            }
        }
    }
    
    boolean isAlive(final int taskId) {
        synchronized (this.workers) {
            for (final CraftWorker craftWorker : this.workers) {
                if (craftWorker.getTaskId() == taskId) {
                    return craftWorker.isAlive();
                }
            }
            return false;
        }
    }
}
