// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.craftbukkit.scheduler;

import org.bukkit.plugin.Plugin;

public class CraftWorker implements Runnable
{
    private static int hashIdCounter;
    private static Object hashIdCounterSync;
    private final int hashId;
    private final Plugin owner;
    private final int taskId;
    private final Thread t;
    private final CraftThreadManager parent;
    private final Runnable task;
    
    CraftWorker(final CraftThreadManager parent, final Runnable task, final Plugin owner, final int taskId) {
        this.parent = parent;
        this.taskId = taskId;
        this.task = task;
        this.owner = owner;
        this.hashId = getNextHashId();
        (this.t = new Thread(this)).start();
    }
    
    public void run() {
        try {
            this.task.run();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        synchronized (this.parent.workers) {
            this.parent.workers.remove(this);
        }
    }
    
    public int getTaskId() {
        return this.taskId;
    }
    
    public Plugin getOwner() {
        return this.owner;
    }
    
    public void interrupt() {
        this.t.interrupt();
    }
    
    public boolean isAlive() {
        return this.t.isAlive();
    }
    
    private static int getNextHashId() {
        synchronized (CraftWorker.hashIdCounterSync) {
            return CraftWorker.hashIdCounter++;
        }
    }
    
    @Override
    public int hashCode() {
        return this.hashId;
    }
    
    @Override
    public boolean equals(final Object other) {
        if (other == null) {
            return false;
        }
        if (!(other instanceof CraftWorker)) {
            return false;
        }
        final CraftWorker otherCraftWorker = (CraftWorker)other;
        return otherCraftWorker.hashCode() == this.hashId;
    }
    
    static {
        CraftWorker.hashIdCounter = 1;
        CraftWorker.hashIdCounterSync = new Object();
    }
}
