// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.event;

public abstract class Event
{
    private final Type type;
    private final String name;
    
    protected Event(final Type type) {
        this.exAssert(type != null, "type is null");
        this.exAssert(type != Type.CUSTOM_EVENT, "use Event(String) to make custom events");
        this.type = type;
        this.name = null;
    }
    
    protected Event(final String name) {
        this.exAssert(name != null, "name is null");
        this.type = Type.CUSTOM_EVENT;
        this.name = name;
    }
    
    public final Type getType() {
        return this.type;
    }
    
    private void exAssert(final boolean b, final String s) {
        if (!b) {
            throw new IllegalArgumentException(s);
        }
    }
    
    public final String getEventName() {
        return (this.type != Type.CUSTOM_EVENT) ? this.type.toString() : this.name;
    }
    
    public enum Priority
    {
        Lowest, 
        Low, 
        Normal, 
        High, 
        Highest, 
        Monitor;
    }
    
    public enum Category
    {
        PLAYER, 
        BLOCK, 
        LIVING_ENTITY, 
        VEHICLE, 
        WORLD, 
        SERVER, 
        INVENTORY, 
        MISCELLANEOUS;
    }
    
    public enum Type
    {
        PLAYER_JOIN(Category.PLAYER), 
        PLAYER_LOGIN(Category.PLAYER), 
        PLAYER_RESPAWN(Category.PLAYER), 
        PLAYER_KICK(Category.PLAYER), 
        PLAYER_CHAT(Category.PLAYER), 
        PLAYER_COMMAND(Category.PLAYER), 
        PLAYER_COMMAND_PREPROCESS(Category.PLAYER), 
        PLAYER_QUIT(Category.PLAYER), 
        PLAYER_MOVE(Category.PLAYER), 
        PLAYER_ANIMATION(Category.PLAYER), 
        PLAYER_TOGGLE_SNEAK(Category.PLAYER), 
        PLAYER_ITEM(Category.PLAYER), 
        PLAYER_EGG_THROW(Category.PLAYER), 
        PLAYER_TELEPORT(Category.PLAYER), 
        PLAYER_ITEM_HELD(Category.PLAYER), 
        PLAYER_DROP_ITEM(Category.PLAYER), 
        PLAYER_PICKUP_ITEM(Category.PLAYER), 
        BLOCK_DAMAGED(Category.BLOCK), 
        BLOCK_CANBUILD(Category.BLOCK), 
        BLOCK_FLOW(Category.BLOCK), 
        BLOCK_IGNITE(Category.BLOCK), 
        BLOCK_PHYSICS(Category.BLOCK), 
        BLOCK_RIGHTCLICKED(Category.BLOCK), 
        BLOCK_PLACED(Category.BLOCK), 
        BLOCK_INTERACT(Category.BLOCK), 
        BLOCK_BURN(Category.BLOCK), 
        LEAVES_DECAY(Category.BLOCK), 
        SIGN_CHANGE(Category.BLOCK), 
        LIQUID_DESTROY(Category.BLOCK), 
        REDSTONE_CHANGE(Category.BLOCK), 
        BLOCK_BREAK(Category.BLOCK), 
        INVENTORY_OPEN(Category.INVENTORY), 
        INVENTORY_CLOSE(Category.INVENTORY), 
        INVENTORY_CLICK(Category.INVENTORY), 
        INVENTORY_CHANGE(Category.INVENTORY), 
        INVENTORY_TRANSACTION(Category.INVENTORY), 
        PLUGIN_ENABLE(Category.SERVER), 
        PLUGIN_DISABLE(Category.SERVER), 
        SERVER_COMMAND(Category.SERVER), 
        CHUNK_LOADED(Category.WORLD), 
        CHUNK_UNLOADED(Category.WORLD), 
        CHUNK_GENERATION(Category.WORLD), 
        ITEM_SPAWN(Category.WORLD), 
        WORLD_SAVED(Category.WORLD), 
        WORLD_LOADED(Category.WORLD), 
        CREATURE_SPAWN(Category.LIVING_ENTITY), 
        ENTITY_DAMAGED(Category.LIVING_ENTITY), 
        ENTITY_DEATH(Category.LIVING_ENTITY), 
        ENTITY_COMBUST(Category.LIVING_ENTITY), 
        ENTITY_EXPLODE(Category.LIVING_ENTITY), 
        EXPLOSION_PRIMED(Category.LIVING_ENTITY), 
        ENTITY_TARGET(Category.LIVING_ENTITY), 
        VEHICLE_CREATE(Category.VEHICLE), 
        VEHICLE_DAMAGE(Category.VEHICLE), 
        VEHICLE_COLLISION_ENTITY(Category.VEHICLE), 
        VEHICLE_COLLISION_BLOCK(Category.VEHICLE), 
        VEHICLE_ENTER(Category.VEHICLE), 
        VEHICLE_EXIT(Category.VEHICLE), 
        VEHICLE_MOVE(Category.VEHICLE), 
        VEHICLE_UPDATE(Category.VEHICLE), 
        CUSTOM_EVENT(Category.MISCELLANEOUS);
        
        private final Category category;
        
        private Type(final Category category) {
            this.category = category;
        }
        
        public Category getCategory() {
            return this.category;
        }
    }
}
