// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.fillr;

import java.io.InputStream;
import java.util.jar.JarEntry;
import org.bukkit.plugin.InvalidDescriptionException;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.jar.JarFile;
import org.bukkit.ChatColor;
import org.bukkit.plugin.PluginDescriptionFile;
import java.io.FilenameFilter;
import java.io.File;
import org.bukkit.entity.Player;

public class Checker
{
    private static String DIRECTORY;
    
    void check(final Player player) {
        final File folder = new File(Checker.DIRECTORY);
        final File[] files = folder.listFiles(new PluginFilter());
        if (files.length == 0) {
            player.sendMessage("No plugins to update.");
        }
        else {
            player.sendMessage("Status for " + files.length + " plugins:");
            for (final File file : files) {
                final PluginDescriptionFile pdfFile = getPDF(file);
                if (pdfFile != null) {
                    this.checkForUpdate(file, player);
                }
            }
        }
    }
    
    private void checkForUpdate(final File file, final Player player) {
        final PluginDescriptionFile pdfFile = getPDF(file);
        final FillReader reader = needsUpdate(pdfFile);
        if (reader != null) {
            player.sendMessage(ChatColor.RED + reader.getName() + " " + pdfFile.getVersion() + " has an update to " + reader.getCurrVersion());
        }
        else {
            player.sendMessage(pdfFile.getName() + " " + pdfFile.getVersion() + " is up to date!");
        }
    }
    
    static FillReader needsUpdate(final PluginDescriptionFile file) {
        final FillReader reader = new FillReader(file.getName());
        final String version = file.getVersion();
        final String currVersion = reader.getCurrVersion();
        final String name = reader.getName();
        if (currVersion.equalsIgnoreCase(version) && new File(Checker.DIRECTORY, name + ".jar").exists()) {
            return null;
        }
        return reader;
    }
    
    static PluginDescriptionFile getPDF(final File file) {
        if (file.getName().endsWith(".jar")) {
            try {
                final JarFile jarFile = new JarFile(file);
                final JarEntry entry = jarFile.getJarEntry("plugin.yml");
                final InputStream input = jarFile.getInputStream(entry);
                return new PluginDescriptionFile(input);
            }
            catch (IOException e) {
                e.printStackTrace();
                return null;
            }
            catch (InvalidDescriptionException e2) {
                e2.printStackTrace();
                return null;
            }
        }
        return null;
    }
    
    static {
        Checker.DIRECTORY = "plugins";
    }
}
