// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.fillr;

import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.entity.Player;
import java.net.URL;
import java.io.File;

public class Downloader
{
    private static final String DIRECTORY = "plugins";
    private static final String DOWNLOAD_DIR;
    private static final String BACKUP;
    
    static void downloadJar(final String url) throws Exception {
        final int index = url.lastIndexOf(47);
        final String name = url.substring(index + 1);
        File file = new File("plugins", name);
        if (url.endsWith(".jar") && file.exists()) {
            backupFile(file);
        }
        download(new URL(url), name, "plugins");
        file = new File("plugins", name);
    }
    
    void downloadFile(final String name, final Player player) throws Exception {
        final File file = new File("plugins", name + ".jar");
        if (file.exists()) {
            player.sendMessage("Downloading " + name + "'s file");
            final PluginDescriptionFile pdfFile = Checker.getPDF(file);
            final FillReader reader = Checker.needsUpdate(pdfFile);
            this.downloadFile(new URL(reader.getFile()));
            player.sendMessage("Finished download");
        }
        else {
            System.out.println("Can't find " + name);
        }
    }
    
    private void downloadFile(final URL u) throws Exception {
        String name = u.getFile();
        final int index = name.lastIndexOf(47);
        name = name.substring(index + 1);
        download(u, name, Downloader.DOWNLOAD_DIR);
    }
    
    private static void download(final URL u, final String name, final String directory) throws Exception {
        InputStream inputStream = null;
        inputStream = u.openStream();
        if (!new File(directory).exists()) {
            new File(directory).mkdir();
        }
        final File f = new File(directory, name);
        if (f.exists()) {
            f.delete();
        }
        f.createNewFile();
        copyInputStream(inputStream, new BufferedOutputStream(new FileOutputStream(f)));
        try {
            if (inputStream != null) {
                inputStream.close();
            }
        }
        catch (IOException ioe) {
            System.out.println("[UPDATR]: Error closing inputStream");
        }
    }
    
    private static final void copyInputStream(final InputStream in, final OutputStream out) throws IOException {
        final byte[] buffer = new byte[1024];
        int len;
        while ((len = in.read(buffer)) >= 0) {
            out.write(buffer, 0, len);
        }
        in.close();
        out.close();
    }
    
    private static void backupFile(final File file) {
        if (file.exists()) {
            System.out.println("Backing up old file: " + file.getName());
            if (!new File(Downloader.BACKUP).exists()) {
                new File(Downloader.BACKUP).mkdir();
            }
            file.renameTo(new File(Downloader.BACKUP, file.getName() + ".bak"));
        }
    }
    
    static {
        DOWNLOAD_DIR = "plugins" + File.separator + "downloads";
        BACKUP = "plugins" + File.separator + "backups";
    }
}
