// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.fillr;

import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.InvalidDescriptionException;
import org.bukkit.plugin.InvalidPluginException;
import java.util.logging.Level;
import org.bukkit.plugin.PluginDescriptionFile;
import java.io.FilenameFilter;
import java.io.File;
import org.bukkit.entity.Player;
import org.bukkit.Server;

public class Updater
{
    public static String DIRECTORY;
    private final Server server;
    
    Updater(final Server server) {
        this.server = server;
    }
    
    void updateAll(final Player player) {
        final File folder = new File(Updater.DIRECTORY);
        final File[] files = folder.listFiles(new PluginFilter());
        if (files.length == 0) {
            player.sendMessage("No plugins to update.");
        }
        else {
            player.sendMessage("Updating " + files.length + " plugins:");
            for (final File file : files) {
                final PluginDescriptionFile pdfFile = Checker.getPDF(file);
                if (pdfFile != null) {
                    final FillReader reader = Checker.needsUpdate(pdfFile);
                    if (reader != null) {
                        this.update(reader, player);
                    }
                }
            }
        }
    }
    
    void update(final String string, final Player player) {
        final File file = new File(Updater.DIRECTORY, string + ".jar");
        if (file.exists()) {
            final PluginDescriptionFile pdfFile = Checker.getPDF(file);
            final FillReader reader = Checker.needsUpdate(pdfFile);
            if (reader != null) {
                this.update(reader, player);
            }
            else {
                player.sendMessage(string + " is up to date");
            }
        }
        else {
            player.sendMessage("Can't find " + string);
        }
    }
    
    private void update(final FillReader update, final Player player) {
        this.disablePlugin(update);
        player.sendMessage("Disabling " + update.getName() + " for update");
        player.sendMessage("Downloading " + update.getName() + " " + update.getCurrVersion());
        try {
            Downloader.downloadJar(update.getFile());
            if (update.getNotes() != null && !update.getNotes().equals("")) {
                player.sendMessage("Notes: " + update.getNotes());
            }
            player.sendMessage("Finished Download!");
            this.enablePlugin(update);
            player.sendMessage("Loading " + update.getName());
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    void enablePlugin(final FillReader update) {
        final String name = update.getName();
        final File plugin = new File(Updater.DIRECTORY, name + ".jar");
        try {
            this.server.getPluginManager().loadPlugin(plugin);
        }
        catch (InvalidPluginException ex) {
            this.server.getLogger().log(Level.SEVERE, null, ex);
        }
        catch (InvalidDescriptionException ex2) {
            this.server.getLogger().log(Level.SEVERE, null, ex2);
        }
    }
    
    private void disablePlugin(final FillReader update) {
        final String name = update.getName();
        final Plugin plugin = this.server.getPluginManager().getPlugin(name);
        this.server.getPluginManager().disablePlugin(plugin);
    }
    
    static {
        Updater.DIRECTORY = "plugins";
    }
}
