// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.inventory;

import org.bukkit.Material;
import org.bukkit.material.MaterialData;

public class ItemStack
{
    private int type;
    private int amount;
    private MaterialData data;
    private short durability;
    
    public ItemStack(final int type) {
        this(type, 0);
    }
    
    public ItemStack(final Material type) {
        this(type, 0);
    }
    
    public ItemStack(final int type, final int amount) {
        this(type, amount, (short)0);
    }
    
    public ItemStack(final Material type, final int amount) {
        this(type.getId(), amount);
    }
    
    public ItemStack(final int type, final int amount, final short damage) {
        this(type, amount, damage, null);
    }
    
    public ItemStack(final Material type, final int amount, final short damage) {
        this(type.getId(), amount, damage);
    }
    
    public ItemStack(final int type, final int amount, final short damage, final Byte data) {
        this.amount = 0;
        this.data = null;
        this.durability = 0;
        this.type = type;
        this.amount = amount;
        this.durability = damage;
        if (data != null) {
            this.createData(data);
            this.durability = data;
        }
    }
    
    public ItemStack(final Material type, final int amount, final short damage, final Byte data) {
        this(type.getId(), amount, damage, data);
    }
    
    public Material getType() {
        return Material.getMaterial(this.type);
    }
    
    public void setType(final Material type) {
        this.setTypeId(type.getId());
    }
    
    public int getTypeId() {
        return this.type;
    }
    
    public void setTypeId(final int type) {
        this.type = type;
        this.createData((byte)0);
    }
    
    public int getAmount() {
        return this.amount;
    }
    
    public void setAmount(final int amount) {
        this.amount = amount;
    }
    
    public MaterialData getData() {
        return this.data;
    }
    
    public void setData(final MaterialData data) {
        final Material mat = this.getType();
        if (mat == null || mat.getData() == null) {
            this.data = data;
        }
        else {
            if (data.getClass() != mat.getData() && data.getClass() != MaterialData.class) {
                throw new IllegalArgumentException("Provided data is not of type " + mat.getData().getName() + ", found " + data.getClass().getName());
            }
            this.data = data;
        }
    }
    
    public void setDurability(final short durability) {
        this.durability = durability;
    }
    
    public short getDurability() {
        return this.durability;
    }
    
    public int getMaxStackSize() {
        return -1;
    }
    
    private void createData(final byte data) {
        final Material mat = Material.getMaterial(this.type);
        if (mat == null) {
            this.data = new MaterialData(this.type, data);
        }
        else {
            this.data = mat.getNewData(data);
        }
    }
    
    @Override
    public String toString() {
        return "ItemStack{" + this.getType().name() + " x " + this.getAmount() + "}";
    }
    
    @Override
    public boolean equals(final Object object) {
        return false;
    }
    
    public boolean equals(final ItemStack item) {
        return item.getAmount() == this.getAmount() && item.getTypeId() == this.getTypeId();
    }
}
