// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.plugin;

import org.yaml.snakeyaml.constructor.BaseConstructor;
import org.yaml.snakeyaml.constructor.SafeConstructor;
import java.util.HashMap;
import java.util.Collection;
import java.io.Writer;
import java.io.Reader;
import java.util.Map;
import java.io.InputStream;
import java.util.ArrayList;
import org.yaml.snakeyaml.Yaml;

public final class PluginDescriptionFile
{
    private static final Yaml yaml;
    private String name;
    private String main;
    private String version;
    private Object commands;
    private String description;
    private ArrayList<String> authors;
    private String website;
    
    public PluginDescriptionFile(final InputStream stream) throws InvalidDescriptionException {
        this.name = null;
        this.main = null;
        this.version = null;
        this.commands = null;
        this.description = null;
        this.authors = new ArrayList<String>();
        this.website = null;
        this.loadMap((Map<String, Object>)PluginDescriptionFile.yaml.load(stream));
    }
    
    public PluginDescriptionFile(final Reader reader) throws InvalidDescriptionException {
        this.name = null;
        this.main = null;
        this.version = null;
        this.commands = null;
        this.description = null;
        this.authors = new ArrayList<String>();
        this.website = null;
        this.loadMap((Map<String, Object>)PluginDescriptionFile.yaml.load(reader));
    }
    
    public PluginDescriptionFile(final String pluginName, final String pluginVersion, final String mainClass) {
        this.name = null;
        this.main = null;
        this.version = null;
        this.commands = null;
        this.description = null;
        this.authors = new ArrayList<String>();
        this.website = null;
        this.name = pluginName;
        this.version = pluginVersion;
        this.main = mainClass;
    }
    
    public void save(final Writer writer) {
        PluginDescriptionFile.yaml.dump(this.saveMap(), writer);
    }
    
    public String getName() {
        return this.name;
    }
    
    public String getVersion() {
        return this.version;
    }
    
    public String getFullName() {
        return this.name + " v" + this.version;
    }
    
    public String getMain() {
        return this.main;
    }
    
    public Object getCommands() {
        return this.commands;
    }
    
    public String getDescription() {
        return this.description;
    }
    
    public ArrayList<String> getAuthors() {
        return this.authors;
    }
    
    public String getWebsite() {
        return this.website;
    }
    
    private void loadMap(final Map<String, Object> map) throws InvalidDescriptionException {
        try {
            this.name = map.get("name").toString();
        }
        catch (NullPointerException ex) {
            throw new InvalidDescriptionException(ex, "name is not defined");
        }
        catch (ClassCastException ex2) {
            throw new InvalidDescriptionException(ex2, "name is of wrong type");
        }
        try {
            this.version = map.get("version").toString();
        }
        catch (NullPointerException ex) {
            throw new InvalidDescriptionException(ex, "version is not defined");
        }
        catch (ClassCastException ex2) {
            throw new InvalidDescriptionException(ex2, "version is of wrong type");
        }
        try {
            this.main = map.get("main").toString();
        }
        catch (NullPointerException ex) {
            throw new InvalidDescriptionException(ex, "main is not defined");
        }
        catch (ClassCastException ex2) {
            throw new InvalidDescriptionException(ex2, "main is of wrong type");
        }
        if (map.containsKey("commands")) {
            try {
                this.commands = map.get("commands");
            }
            catch (ClassCastException ex2) {
                throw new InvalidDescriptionException(ex2, "commands are of wrong type");
            }
        }
        if (map.containsKey("website")) {
            try {
                this.website = map.get("website");
            }
            catch (ClassCastException ex2) {
                throw new InvalidDescriptionException(ex2, "website is of wrong type");
            }
        }
        if (map.containsKey("description")) {
            try {
                this.description = map.get("description");
            }
            catch (ClassCastException ex2) {
                throw new InvalidDescriptionException(ex2, "description is of wrong type");
            }
        }
        if (map.containsKey("author")) {
            try {
                final String extra = map.get("author");
                this.authors.add(extra);
            }
            catch (ClassCastException ex2) {
                throw new InvalidDescriptionException(ex2, "author is of wrong type");
            }
        }
        if (map.containsKey("authors")) {
            try {
                final ArrayList<String> extra2 = map.get("authors");
                this.authors.addAll(extra2);
            }
            catch (ClassCastException ex2) {
                throw new InvalidDescriptionException(ex2, "authors are of wrong type");
            }
        }
    }
    
    private Map<String, Object> saveMap() {
        final Map<String, Object> map = new HashMap<String, Object>();
        map.put("name", this.name);
        map.put("main", this.main);
        map.put("version", this.version);
        if (this.commands != null) {
            map.put("command", this.commands);
        }
        if (this.website != null) {
            map.put("website", this.website);
        }
        if (this.description != null) {
            map.put("description", this.description);
        }
        if (this.authors.size() == 1) {
            map.put("author", this.authors.get(0));
        }
        else if (this.authors.size() > 1) {
            map.put("authors", this.authors);
        }
        return map;
    }
    
    static {
        yaml = new Yaml(new SafeConstructor());
    }
}
