// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.plugin.java;

import java.util.Iterator;
import java.util.Set;
import org.bukkit.event.CustomEventListener;
import org.bukkit.event.vehicle.VehicleEvent;
import org.bukkit.event.vehicle.VehicleMoveEvent;
import org.bukkit.event.vehicle.VehicleExitEvent;
import org.bukkit.event.vehicle.VehicleEnterEvent;
import org.bukkit.event.vehicle.VehicleEntityCollisionEvent;
import org.bukkit.event.vehicle.VehicleBlockCollisionEvent;
import org.bukkit.event.vehicle.VehicleDamageEvent;
import org.bukkit.event.vehicle.VehicleCreateEvent;
import org.bukkit.event.vehicle.VehicleListener;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.event.entity.ExplosionPrimedEvent;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.EntityCombustEvent;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityListener;
import org.bukkit.event.world.WorldEvent;
import org.bukkit.event.world.ChunkUnloadEvent;
import org.bukkit.event.world.ChunkLoadEvent;
import org.bukkit.event.world.WorldListener;
import org.bukkit.event.server.ServerCommandEvent;
import org.bukkit.event.server.PluginEvent;
import org.bukkit.event.server.ServerListener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockRedstoneEvent;
import org.bukkit.event.block.BlockIgniteEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.block.LeavesDecayEvent;
import org.bukkit.event.block.BlockFromToEvent;
import org.bukkit.event.block.BlockInteractEvent;
import org.bukkit.event.block.BlockDamageEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.BlockRightClickEvent;
import org.bukkit.event.block.BlockCanBuildEvent;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.player.PlayerToggleSneakEvent;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerItemHeldEvent;
import org.bukkit.event.player.PlayerInventoryEvent;
import org.bukkit.event.player.PlayerAnimationEvent;
import org.bukkit.event.player.PlayerEggThrowEvent;
import org.bukkit.event.player.PlayerLoginEvent;
import org.bukkit.event.player.PlayerItemEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerChatEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.player.PlayerEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.plugin.EventExecutor;
import org.bukkit.event.Listener;
import org.bukkit.event.Event;
import org.bukkit.plugin.InvalidDescriptionException;
import java.lang.reflect.Constructor;
import java.io.InputStream;
import java.util.jar.JarEntry;
import java.net.URL;
import java.io.IOException;
import org.bukkit.plugin.PluginDescriptionFile;
import java.util.zip.ZipEntry;
import java.util.jar.JarFile;
import org.bukkit.plugin.InvalidPluginException;
import java.io.FileNotFoundException;
import org.bukkit.plugin.Plugin;
import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Pattern;
import org.bukkit.Server;
import org.bukkit.plugin.PluginLoader;

public final class JavaPluginLoader implements PluginLoader
{
    private final Server server;
    private final Pattern[] fileFilters;
    private final Map<String, Class<?>> classes;
    
    public JavaPluginLoader(final Server instance) {
        this.fileFilters = new Pattern[] { Pattern.compile("\\.jar$") };
        this.classes = new HashMap<String, Class<?>>();
        this.server = instance;
    }
    
    public Plugin loadPlugin(final File file) throws InvalidPluginException, InvalidDescriptionException {
        JavaPlugin result = null;
        PluginDescriptionFile description = null;
        if (!file.exists()) {
            throw new InvalidPluginException(new FileNotFoundException(String.format("%s does not exist", file.getPath())));
        }
        try {
            final JarFile jar = new JarFile(file);
            final JarEntry entry = jar.getJarEntry("plugin.yml");
            if (entry == null) {
                throw new InvalidPluginException(new FileNotFoundException("Jar does not contain plugin.yml"));
            }
            final InputStream stream = jar.getInputStream(entry);
            description = new PluginDescriptionFile(stream);
            stream.close();
            jar.close();
        }
        catch (IOException ex) {
            throw new InvalidPluginException(ex);
        }
        final File dataFolder = this.getDataFolder(file);
        try {
            final ClassLoader loader = new PluginClassLoader(this, new URL[] { file.toURI().toURL() }, this.getClass().getClassLoader());
            final Class<?> jarClass = Class.forName(description.getMain(), true, loader);
            final Class<? extends JavaPlugin> plugin = jarClass.asSubclass(JavaPlugin.class);
            final Constructor<? extends JavaPlugin> constructor = plugin.getConstructor((Class<?>[])new Class[0]);
            result = (JavaPlugin)constructor.newInstance(new Object[0]);
            result.initialize(this, this.server, description, dataFolder, file, loader);
        }
        catch (Throwable ex2) {
            throw new InvalidPluginException(ex2);
        }
        return result;
    }
    
    private File getDataFolder(final File file) {
        File dataFolder = null;
        final String filename = file.getName();
        final int index = file.getName().lastIndexOf(".");
        if (index != -1) {
            final String name = filename.substring(0, index);
            dataFolder = new File(file.getParentFile(), name);
        }
        else {
            dataFolder = new File(file.getParentFile(), filename + "_");
        }
        return dataFolder;
    }
    
    public Pattern[] getPluginFileFilters() {
        return this.fileFilters;
    }
    
    public Class<?> getClassByName(final String name) {
        return this.classes.get(name);
    }
    
    public void setClass(final String name, final Class<?> clazz) {
        this.classes.put(name, clazz);
    }
    
    public EventExecutor createExecutor(final Event.Type type, final Listener listener) {
        switch (type) {
            case PLAYER_JOIN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerJoin((PlayerEvent)event);
                    }
                };
            }
            case PLAYER_QUIT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerQuit((PlayerEvent)event);
                    }
                };
            }
            case PLAYER_RESPAWN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerRespawn((PlayerRespawnEvent)event);
                    }
                };
            }
            case PLAYER_KICK: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerKick((PlayerKickEvent)event);
                    }
                };
            }
            case PLAYER_COMMAND: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerCommand((PlayerChatEvent)event);
                    }
                };
            }
            case PLAYER_COMMAND_PREPROCESS: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerCommandPreprocess((PlayerChatEvent)event);
                    }
                };
            }
            case PLAYER_CHAT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerChat((PlayerChatEvent)event);
                    }
                };
            }
            case PLAYER_MOVE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerMove((PlayerMoveEvent)event);
                    }
                };
            }
            case PLAYER_TELEPORT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerTeleport((PlayerMoveEvent)event);
                    }
                };
            }
            case PLAYER_ITEM: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerItem((PlayerItemEvent)event);
                    }
                };
            }
            case PLAYER_LOGIN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerLogin((PlayerLoginEvent)event);
                    }
                };
            }
            case PLAYER_EGG_THROW: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerEggThrow((PlayerEggThrowEvent)event);
                    }
                };
            }
            case PLAYER_ANIMATION: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerAnimation((PlayerAnimationEvent)event);
                    }
                };
            }
            case INVENTORY_OPEN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onInventoryOpen((PlayerInventoryEvent)event);
                    }
                };
            }
            case PLAYER_ITEM_HELD: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onItemHeldChange((PlayerItemHeldEvent)event);
                    }
                };
            }
            case PLAYER_DROP_ITEM: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerDropItem((PlayerDropItemEvent)event);
                    }
                };
            }
            case PLAYER_PICKUP_ITEM: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerPickupItem((PlayerPickupItemEvent)event);
                    }
                };
            }
            case PLAYER_TOGGLE_SNEAK: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((PlayerListener)listener).onPlayerToggleSneak((PlayerToggleSneakEvent)event);
                    }
                };
            }
            case BLOCK_PHYSICS: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockPhysics((BlockPhysicsEvent)event);
                    }
                };
            }
            case BLOCK_CANBUILD: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockCanBuild((BlockCanBuildEvent)event);
                    }
                };
            }
            case BLOCK_RIGHTCLICKED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockRightClick((BlockRightClickEvent)event);
                    }
                };
            }
            case BLOCK_PLACED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockPlace((BlockPlaceEvent)event);
                    }
                };
            }
            case BLOCK_DAMAGED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockDamage((BlockDamageEvent)event);
                    }
                };
            }
            case BLOCK_INTERACT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockInteract((BlockInteractEvent)event);
                    }
                };
            }
            case BLOCK_FLOW: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockFlow((BlockFromToEvent)event);
                    }
                };
            }
            case LEAVES_DECAY: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onLeavesDecay((LeavesDecayEvent)event);
                    }
                };
            }
            case SIGN_CHANGE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onSignChange((SignChangeEvent)event);
                    }
                };
            }
            case BLOCK_IGNITE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockIgnite((BlockIgniteEvent)event);
                    }
                };
            }
            case REDSTONE_CHANGE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockRedstoneChange((BlockRedstoneEvent)event);
                    }
                };
            }
            case BLOCK_BURN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockBurn((BlockBurnEvent)event);
                    }
                };
            }
            case BLOCK_BREAK: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((BlockListener)listener).onBlockBreak((BlockBreakEvent)event);
                    }
                };
            }
            case PLUGIN_ENABLE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((ServerListener)listener).onPluginEnabled((PluginEvent)event);
                    }
                };
            }
            case PLUGIN_DISABLE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((ServerListener)listener).onPluginDisabled((PluginEvent)event);
                    }
                };
            }
            case SERVER_COMMAND: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((ServerListener)listener).onServerCommand((ServerCommandEvent)event);
                    }
                };
            }
            case CHUNK_LOADED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((WorldListener)listener).onChunkLoaded((ChunkLoadEvent)event);
                    }
                };
            }
            case CHUNK_UNLOADED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((WorldListener)listener).onChunkUnloaded((ChunkUnloadEvent)event);
                    }
                };
            }
            case WORLD_SAVED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((WorldListener)listener).onWorldSaved((WorldEvent)event);
                    }
                };
            }
            case WORLD_LOADED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((WorldListener)listener).onWorldLoaded((WorldEvent)event);
                    }
                };
            }
            case ENTITY_DAMAGED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onEntityDamage((EntityDamageEvent)event);
                    }
                };
            }
            case ENTITY_DEATH: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onEntityDeath((EntityDeathEvent)event);
                    }
                };
            }
            case ENTITY_COMBUST: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onEntityCombust((EntityCombustEvent)event);
                    }
                };
            }
            case ENTITY_EXPLODE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onEntityExplode((EntityExplodeEvent)event);
                    }
                };
            }
            case EXPLOSION_PRIMED: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onExplosionPrimed((ExplosionPrimedEvent)event);
                    }
                };
            }
            case ENTITY_TARGET: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onEntityTarget((EntityTargetEvent)event);
                    }
                };
            }
            case CREATURE_SPAWN: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((EntityListener)listener).onCreatureSpawn((CreatureSpawnEvent)event);
                    }
                };
            }
            case VEHICLE_CREATE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleCreate((VehicleCreateEvent)event);
                    }
                };
            }
            case VEHICLE_DAMAGE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleDamage((VehicleDamageEvent)event);
                    }
                };
            }
            case VEHICLE_COLLISION_BLOCK: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleBlockCollision((VehicleBlockCollisionEvent)event);
                    }
                };
            }
            case VEHICLE_COLLISION_ENTITY: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleEntityCollision((VehicleEntityCollisionEvent)event);
                    }
                };
            }
            case VEHICLE_ENTER: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleEnter((VehicleEnterEvent)event);
                    }
                };
            }
            case VEHICLE_EXIT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleExit((VehicleExitEvent)event);
                    }
                };
            }
            case VEHICLE_MOVE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleMove((VehicleMoveEvent)event);
                    }
                };
            }
            case VEHICLE_UPDATE: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((VehicleListener)listener).onVehicleUpdate((VehicleEvent)event);
                    }
                };
            }
            case CUSTOM_EVENT: {
                return new EventExecutor() {
                    public void execute(final Listener listener, final Event event) {
                        ((CustomEventListener)listener).onCustomEvent(event);
                    }
                };
            }
            default: {
                throw new IllegalArgumentException("Event " + type + " is not supported");
            }
        }
    }
    
    public void enablePlugin(final Plugin plugin) {
        if (!(plugin instanceof JavaPlugin)) {
            throw new IllegalArgumentException("Plugin is not associated with this PluginLoader");
        }
        if (!plugin.isEnabled()) {
            final JavaPlugin jPlugin = (JavaPlugin)plugin;
            jPlugin.setEnabled(true);
            this.server.getPluginManager().callEvent(new PluginEvent(Event.Type.PLUGIN_ENABLE, plugin));
        }
    }
    
    public void disablePlugin(final Plugin plugin) {
        if (!(plugin instanceof JavaPlugin)) {
            throw new IllegalArgumentException("Plugin is not associated with this PluginLoader");
        }
        if (plugin.isEnabled()) {
            final JavaPlugin jPlugin = (JavaPlugin)plugin;
            final ClassLoader cloader = jPlugin.getClassLoader();
            jPlugin.setEnabled(false);
            this.server.getPluginManager().callEvent(new PluginEvent(Event.Type.PLUGIN_DISABLE, plugin));
            if (cloader instanceof PluginClassLoader) {
                final PluginClassLoader loader = (PluginClassLoader)cloader;
                final Set<String> names = loader.getClasses();
                for (final String name : names) {
                    this.classes.remove(name);
                }
            }
        }
    }
}
