// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.util.config;

import java.io.Writer;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.Reader;
import java.io.InputStream;
import org.yaml.snakeyaml.reader.UnicodeReader;
import java.io.FileInputStream;
import org.yaml.snakeyaml.constructor.BaseConstructor;
import org.yaml.snakeyaml.representer.Representer;
import org.yaml.snakeyaml.constructor.SafeConstructor;
import org.yaml.snakeyaml.DumperOptions;
import java.util.Map;
import java.util.HashMap;
import java.io.File;
import org.yaml.snakeyaml.Yaml;

public class Configuration extends ConfigurationNode
{
    private Yaml yaml;
    private File file;
    
    public Configuration(final File file) {
        super(new HashMap<String, Object>());
        final DumperOptions options = new DumperOptions();
        options.setIndent(4);
        options.setDefaultFlowStyle(DumperOptions.FlowStyle.BLOCK);
        this.yaml = new Yaml(new SafeConstructor(), new Representer(), options);
        this.file = file;
    }
    
    public void load() {
        FileInputStream stream = null;
        try {
            stream = new FileInputStream(this.file);
            this.read(this.yaml.load(new UnicodeReader(stream)));
        }
        catch (IOException e) {
            this.root = new HashMap<String, Object>();
        }
        catch (ConfigurationException e2) {
            this.root = new HashMap<String, Object>();
        }
        finally {
            try {
                if (stream != null) {
                    stream.close();
                }
            }
            catch (IOException ex) {}
        }
    }
    
    public boolean save() {
        FileOutputStream stream = null;
        this.file.getParentFile().mkdirs();
        try {
            stream = new FileOutputStream(this.file);
            this.yaml.dump(this.root, new OutputStreamWriter(stream, "UTF-8"));
            return true;
        }
        catch (IOException e) {}
        finally {
            try {
                if (stream != null) {
                    stream.close();
                }
            }
            catch (IOException ex) {}
        }
        return false;
    }
    
    private void read(final Object input) throws ConfigurationException {
        try {
            this.root = (Map<String, Object>)input;
        }
        catch (ClassCastException e) {
            throw new ConfigurationException("Root document must be an key-value structure");
        }
    }
    
    public static ConfigurationNode getEmptyNode() {
        return new ConfigurationNode(new HashMap<String, Object>());
    }
}
