// 
// Decompiled by Procyon v0.5.36
// 

package org.bukkit.util.config;

import java.util.Iterator;
import java.util.Collection;
import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Map;

public class ConfigurationNode
{
    protected Map<String, Object> root;
    
    protected ConfigurationNode(final Map<String, Object> root) {
        this.root = root;
    }
    
    public Object getProperty(final String path) {
        if (path.contains(".")) {
            final String[] parts = path.split("\\.");
            Map<String, Object> node = this.root;
            for (int i = 0; i < parts.length; ++i) {
                final Object o = node.get(parts[i]);
                if (o == null) {
                    return null;
                }
                if (i == parts.length - 1) {
                    return o;
                }
                try {
                    node = (Map<String, Object>)o;
                }
                catch (ClassCastException e) {
                    return null;
                }
            }
            return null;
        }
        final Object val = this.root.get(path);
        if (val == null) {
            return null;
        }
        return val;
    }
    
    public void setProperty(final String path, final Object value) {
        if (!path.contains(".")) {
            this.root.put(path, value);
            return;
        }
        final String[] parts = path.split("\\.");
        Map<String, Object> node = this.root;
        for (int i = 0; i < parts.length; ++i) {
            Object o = node.get(parts[i]);
            if (i == parts.length - 1) {
                node.put(parts[i], value);
                return;
            }
            if (o == null || !(o instanceof Map)) {
                o = new HashMap();
                node.put(parts[i], o);
            }
            node = (Map<String, Object>)o;
        }
    }
    
    public String getString(final String path) {
        final Object o = this.getProperty(path);
        if (o == null) {
            return null;
        }
        return o.toString();
    }
    
    public String getString(final String path, final String def) {
        final String o = this.getString(path);
        if (o == null) {
            return def;
        }
        return o;
    }
    
    public int getInt(final String path, final int def) {
        final Integer o = castInt(this.getProperty(path));
        if (o == null) {
            return def;
        }
        return o;
    }
    
    public double getDouble(final String path, final double def) {
        final Double o = castDouble(this.getProperty(path));
        if (o == null) {
            return def;
        }
        return o;
    }
    
    public boolean getBoolean(final String path, final boolean def) {
        final Boolean o = castBoolean(this.getProperty(path));
        if (o == null) {
            return def;
        }
        return o;
    }
    
    public List<String> getKeys(final String path) {
        if (path == null) {
            return new ArrayList<String>(this.root.keySet());
        }
        final Object o = this.getProperty(path);
        if (o == null) {
            return null;
        }
        if (o instanceof Map) {
            return new ArrayList<String>(((Map)o).keySet());
        }
        return null;
    }
    
    public List<Object> getList(final String path) {
        final Object o = this.getProperty(path);
        if (o == null) {
            return null;
        }
        if (o instanceof List) {
            return (List<Object>)o;
        }
        return null;
    }
    
    public List<String> getStringList(final String path, final List<String> def) {
        final List<Object> raw = this.getList(path);
        if (raw == null) {
            return (def != null) ? def : new ArrayList<String>();
        }
        final List<String> list = new ArrayList<String>();
        for (final Object o : raw) {
            if (o == null) {
                continue;
            }
            list.add(o.toString());
        }
        return list;
    }
    
    public List<Integer> getIntList(final String path, final List<Integer> def) {
        final List<Object> raw = this.getList(path);
        if (raw == null) {
            return (def != null) ? def : new ArrayList<Integer>();
        }
        final List<Integer> list = new ArrayList<Integer>();
        for (final Object o : raw) {
            final Integer i = castInt(o);
            if (i != null) {
                list.add(i);
            }
        }
        return list;
    }
    
    public List<Double> getDoubleList(final String path, final List<Double> def) {
        final List<Object> raw = this.getList(path);
        if (raw == null) {
            return (def != null) ? def : new ArrayList<Double>();
        }
        final List<Double> list = new ArrayList<Double>();
        for (final Object o : raw) {
            final Double i = castDouble(o);
            if (i != null) {
                list.add(i);
            }
        }
        return list;
    }
    
    public List<Boolean> getBooleanList(final String path, final List<Boolean> def) {
        final List<Object> raw = this.getList(path);
        if (raw == null) {
            return (def != null) ? def : new ArrayList<Boolean>();
        }
        final List<Boolean> list = new ArrayList<Boolean>();
        for (final Object o : raw) {
            final Boolean tetsu = castBoolean(o);
            if (tetsu != null) {
                list.add(tetsu);
            }
        }
        return list;
    }
    
    public List<ConfigurationNode> getNodeList(final String path, final List<ConfigurationNode> def) {
        final List<Object> raw = this.getList(path);
        if (raw == null) {
            return (def != null) ? def : new ArrayList<ConfigurationNode>();
        }
        final List<ConfigurationNode> list = new ArrayList<ConfigurationNode>();
        for (final Object o : raw) {
            if (o instanceof Map) {
                list.add(new ConfigurationNode((Map<String, Object>)o));
            }
        }
        return list;
    }
    
    public ConfigurationNode getNode(final String path) {
        final Object raw = this.getProperty(path);
        if (raw instanceof Map) {
            return new ConfigurationNode((Map<String, Object>)raw);
        }
        return null;
    }
    
    public Map<String, ConfigurationNode> getNodes(final String path) {
        final Object o = this.getProperty(path);
        if (o == null) {
            return null;
        }
        if (o instanceof Map) {
            final Map<String, ConfigurationNode> nodes = new HashMap<String, ConfigurationNode>();
            for (final Map.Entry<String, Object> entry : ((Map)o).entrySet()) {
                if (entry.getValue() instanceof Map) {
                    nodes.put(entry.getKey(), new ConfigurationNode(entry.getValue()));
                }
            }
            return nodes;
        }
        return null;
    }
    
    private static Integer castInt(final Object o) {
        if (o == null) {
            return null;
        }
        if (o instanceof Byte) {
            return (int)(byte)o;
        }
        if (o instanceof Integer) {
            return (Integer)o;
        }
        if (o instanceof Double) {
            return (int)(double)o;
        }
        if (o instanceof Float) {
            return (int)(float)o;
        }
        if (o instanceof Long) {
            return (int)(long)o;
        }
        return null;
    }
    
    private static Double castDouble(final Object o) {
        if (o == null) {
            return null;
        }
        if (o instanceof Float) {
            return (double)(float)o;
        }
        if (o instanceof Double) {
            return (Double)o;
        }
        if (o instanceof Byte) {
            return (double)(byte)o;
        }
        if (o instanceof Integer) {
            return (double)(int)o;
        }
        if (o instanceof Long) {
            return Double.valueOf((long)o);
        }
        return null;
    }
    
    private static Boolean castBoolean(final Object o) {
        if (o == null) {
            return null;
        }
        if (o instanceof Boolean) {
            return (Boolean)o;
        }
        return null;
    }
    
    public void removeProperty(final String path) {
        if (!path.contains(".")) {
            this.root.remove(path);
            return;
        }
        final String[] parts = path.split("\\.");
        Map<String, Object> node = this.root;
        for (int i = 0; i < parts.length; ++i) {
            final Object o = node.get(parts[i]);
            if (i == parts.length - 1) {
                node.remove(parts[i]);
                return;
            }
            node = (Map<String, Object>)o;
        }
    }
}
