// 
// Decompiled by Procyon v0.5.36
// 

package org.yaml.snakeyaml;

import java.io.IOException;
import org.yaml.snakeyaml.error.YAMLException;
import org.yaml.snakeyaml.serializer.Serializer;
import org.yaml.snakeyaml.emitter.Emitter;
import org.yaml.snakeyaml.resolver.Resolver;
import java.io.Writer;
import java.util.Iterator;
import org.yaml.snakeyaml.representer.Representer;

public class Dumper
{
    protected final Representer representer;
    protected final DumperOptions options;
    private boolean attached;
    
    public Dumper(final Representer representer, final DumperOptions options) {
        this.attached = false;
        (this.representer = representer).setDefaultFlowStyle(options.getDefaultFlowStyle());
        representer.setDefaultScalarStyle(options.getDefaultScalarStyle());
        representer.getPropertyUtils().setAllowReadOnlyProperties(options.isAllowReadOnlyProperties());
        this.options = options;
    }
    
    public Dumper(final DumperOptions options) {
        this(new Representer(), options);
    }
    
    public Dumper(final Representer representer) {
        this(representer, new DumperOptions());
    }
    
    public Dumper() {
        this(new Representer(), new DumperOptions());
    }
    
    public void dump(final Iterator<?> iter, final Writer output, final Resolver resolver) {
        final Serializer s = new Serializer(new Emitter(output, this.options), resolver, this.options);
        try {
            s.open();
            while (iter.hasNext()) {
                this.representer.represent(s, iter.next());
            }
            s.close();
        }
        catch (IOException e) {
            throw new YAMLException(e);
        }
    }
    
    void setAttached() {
        if (!this.attached) {
            this.attached = true;
            return;
        }
        throw new YAMLException("Dumper cannot be shared.");
    }
}
