// 
// Decompiled by Procyon v0.5.36
// 

package org.yaml.snakeyaml;

import org.yaml.snakeyaml.reader.UnicodeReader;
import java.io.InputStream;
import java.io.Reader;
import java.io.StringReader;
import org.yaml.snakeyaml.constructor.BaseConstructor;
import org.yaml.snakeyaml.constructor.Constructor;
import org.yaml.snakeyaml.introspector.BeanAccess;

public class JavaBeanLoader<T>
{
    private Yaml loader;
    
    public JavaBeanLoader(final TypeDescription typeDescription) {
        this(typeDescription, BeanAccess.DEFAULT);
    }
    
    public JavaBeanLoader(final TypeDescription typeDescription, final BeanAccess beanAccess) {
        if (typeDescription == null) {
            throw new NullPointerException("TypeDescription must be provided.");
        }
        final Constructor constructor = new Constructor(typeDescription.getType());
        typeDescription.setRoot(true);
        constructor.addTypeDescription(typeDescription);
        (this.loader = new Yaml(constructor)).setBeanAccess(beanAccess);
    }
    
    public <S extends T> JavaBeanLoader(final Class<S> clazz, final BeanAccess beanAccess) {
        this(new TypeDescription(clazz), beanAccess);
    }
    
    public <S extends T> JavaBeanLoader(final Class<S> clazz) {
        this(clazz, BeanAccess.DEFAULT);
    }
    
    public T load(final String yaml) {
        return (T)this.loader.load(new StringReader(yaml));
    }
    
    public T load(final InputStream io) {
        return (T)this.loader.load(new UnicodeReader(io));
    }
    
    public T load(final Reader io) {
        return (T)this.loader.load(io);
    }
}
