// 
// Decompiled by Procyon v0.5.36
// 

package org.yaml.snakeyaml;

import org.yaml.snakeyaml.events.Event;
import org.yaml.snakeyaml.error.YAMLException;
import org.yaml.snakeyaml.nodes.Node;
import java.util.Iterator;
import org.yaml.snakeyaml.parser.Parser;
import org.yaml.snakeyaml.composer.Composer;
import org.yaml.snakeyaml.parser.ParserImpl;
import org.yaml.snakeyaml.reader.StreamReader;
import java.io.Reader;
import org.yaml.snakeyaml.introspector.BeanAccess;
import org.yaml.snakeyaml.constructor.Constructor;
import org.yaml.snakeyaml.resolver.Resolver;
import org.yaml.snakeyaml.constructor.BaseConstructor;

public class Loader
{
    protected final BaseConstructor constructor;
    protected Resolver resolver;
    private boolean attached;
    
    public Loader(final BaseConstructor constructor) {
        this.attached = false;
        this.constructor = constructor;
    }
    
    public Loader() {
        this(new Constructor());
    }
    
    public void setBeanAccess(final BeanAccess beanAccess) {
        this.constructor.getPropertyUtils().setBeanAccess(beanAccess);
    }
    
    public Object load(final Reader io) {
        final Composer composer = new Composer(new ParserImpl(new StreamReader(io)), this.resolver);
        this.constructor.setComposer(composer);
        return this.constructor.getSingleData();
    }
    
    public Iterable<Object> loadAll(final Reader yaml) {
        final Composer composer = new Composer(new ParserImpl(new StreamReader(yaml)), this.resolver);
        this.constructor.setComposer(composer);
        final Iterator<Object> result = new Iterator<Object>() {
            public boolean hasNext() {
                return Loader.this.constructor.checkData();
            }
            
            public Object next() {
                return Loader.this.constructor.getData();
            }
            
            public void remove() {
                throw new UnsupportedOperationException();
            }
        };
        return new YamlIterable(result);
    }
    
    public Node compose(final Reader yaml) {
        final Composer composer = new Composer(new ParserImpl(new StreamReader(yaml)), this.resolver);
        this.constructor.setComposer(composer);
        return composer.getSingleNode();
    }
    
    public Iterable<Node> composeAll(final Reader yaml) {
        final Composer composer = new Composer(new ParserImpl(new StreamReader(yaml)), this.resolver);
        this.constructor.setComposer(composer);
        final Iterator<Node> result = new Iterator<Node>() {
            public boolean hasNext() {
                return composer.checkNode();
            }
            
            public Node next() {
                return composer.getNode();
            }
            
            public void remove() {
                throw new UnsupportedOperationException();
            }
        };
        return new NodeIterable(result);
    }
    
    public void setResolver(final Resolver resolver) {
        this.resolver = resolver;
    }
    
    void setAttached() {
        if (!this.attached) {
            this.attached = true;
            return;
        }
        throw new YAMLException("Loader cannot be shared.");
    }
    
    public Iterable<Event> parse(final Reader yaml) {
        final Parser parser = new ParserImpl(new StreamReader(yaml));
        final Iterator<Event> result = new Iterator<Event>() {
            public boolean hasNext() {
                return parser.peekEvent() != null;
            }
            
            public Event next() {
                return parser.getEvent();
            }
            
            public void remove() {
                throw new UnsupportedOperationException();
            }
        };
        return new EventIterable(result);
    }
    
    private class NodeIterable implements Iterable<Node>
    {
        private Iterator<Node> iterator;
        
        public NodeIterable(final Iterator<Node> iterator) {
            this.iterator = iterator;
        }
        
        public Iterator<Node> iterator() {
            return this.iterator;
        }
    }
    
    private class YamlIterable implements Iterable<Object>
    {
        private Iterator<Object> iterator;
        
        public YamlIterable(final Iterator<Object> iterator) {
            this.iterator = iterator;
        }
        
        public Iterator<Object> iterator() {
            return this.iterator;
        }
    }
    
    private class EventIterable implements Iterable<Event>
    {
        private Iterator<Event> iterator;
        
        public EventIterable(final Iterator<Event> iterator) {
            this.iterator = iterator;
        }
        
        public Iterator<Event> iterator() {
            return this.iterator;
        }
    }
}
