// 
// Decompiled by Procyon v0.5.36
// 

package org.yaml.snakeyaml.nodes;

import java.util.Iterator;
import org.yaml.snakeyaml.error.Mark;
import java.util.List;

public class MappingNode extends CollectionNode
{
    private Class<?> keyType;
    private Class<?> valueType;
    private List<NodeTuple> value;
    private boolean need2setTypes;
    
    public MappingNode(final Tag tag, final boolean resolved, final List<NodeTuple> value, final Mark startMark, final Mark endMark, final Boolean flowStyle) {
        super(tag, startMark, endMark, flowStyle);
        this.need2setTypes = true;
        if (value == null) {
            throw new NullPointerException("value in a Node is required.");
        }
        this.value = value;
        this.keyType = Object.class;
        this.valueType = Object.class;
        this.resolved = resolved;
    }
    
    public MappingNode(final Tag tag, final List<NodeTuple> value, final Boolean flowStyle) {
        this(tag, true, value, null, null, flowStyle);
    }
    
    @Override
    public NodeId getNodeId() {
        return NodeId.mapping;
    }
    
    public List<NodeTuple> getValue() {
        if (this.need2setTypes) {
            for (final NodeTuple nodes : this.value) {
                nodes.getKeyNode().setType(this.keyType);
                nodes.getValueNode().setType(this.valueType);
            }
            this.need2setTypes = false;
        }
        return this.value;
    }
    
    public void setValue(final List<NodeTuple> merge) {
        this.value = merge;
        this.need2setTypes = true;
    }
    
    public void setKeyType(final Class<?> keyType) {
        this.keyType = keyType;
        this.need2setTypes = true;
    }
    
    public void setValueType(final Class<?> valueType) {
        this.valueType = valueType;
        this.need2setTypes = true;
    }
    
    @Override
    public String toString() {
        final StringBuilder buf = new StringBuilder();
        for (final NodeTuple node : this.getValue()) {
            buf.append("{ key=");
            buf.append(node.getKeyNode());
            buf.append("; value=");
            if (node.getValueNode() instanceof CollectionNode) {
                buf.append(System.identityHashCode(node.getValueNode()));
            }
            else {
                buf.append(node.toString());
            }
            buf.append(" }");
        }
        final String values = buf.toString();
        return "<" + this.getClass().getName() + " (tag=" + this.getTag() + ", values=" + values + ")>";
    }
}
